/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import javax.swing.*;
public class Fedit_penukaran_poin extends Fedit {
    public Fedit_penukaran_poin(final Window parent) {
        super(parent, "Edit Penukaran Poin", "Edit Data Penukaran Poin");
        setVisible(true);
    }
    @Override void build_sql() {
        db = new db_connection() {    //indahnya inherit :)        //private static db_connection db = retail.db;
            @Override public void setValueAt(Object val, int row_idx, int col_idx) {
                //JOptionPane.showMessageDialog( null, "\nval=" + val.toString() + "\ntext=" + ((JTextComponent) Ccode_brg.getEditor().getEditorComponent()).getText() + "\nselectedindex=" + Ccode_brg.getSelectedIndex() , "title", JOptionPane.ERROR_MESSAGE);
                if( to_str( col_idx, getValueAt(row_idx, col_idx).toString().trim() ).equals( to_str(col_idx, val.toString().trim()) ) ) return;
                if( col_idx==1 || col_idx==2 ) {
                    String pelanggan_id;  String pelanggan_id_was;  String poin;
                    if( col_idx==1 ) {    //jika pelanggan diedit, ....
                        pelanggan_id     = retail.convert_null( String.valueOf( ((jcdb_item) ((JComboBox)col_editor[col_idx]).getSelectedItem()).get_id() ) );
                        pelanggan_id_was = to_db(col_idx, getValueAt(row_idx, col_idx));
                        poin             = to_db(2, getValueAt(row_idx, 2));
                        if( pelanggan_id_was.isEmpty() ) pelanggan_id_was = "-1313";
                        sql = " SET @succeed=0 ;\n"
                            + " UPDATE pelanggan SET poin = poin - " +poin+ " + 1-(@succeed:=1) WHERE id = " +pelanggan_id+ " AND poin >= " +poin+ "  ;\n"
                            + " UPDATE pelanggan SET poin = poin + " +poin+ " WHERE @succeed=1 AND id = " +pelanggan_id_was+ " ;\n" ;
                    } else {    //jika poin diedit, ....
                        pelanggan_id     = to_db(1, getValueAt(row_idx, 1));
                        poin             = to_db(col_idx, getValueAt(row_idx, col_idx)) + " - " + val.toString();
                        sql = " UPDATE pelanggan SET poin = poin + " +poin+ " WHERE id = " +pelanggan_id+ " AND poin >= -1 * (" +poin+ ")  ;\n" ;
                    }
                    if( !pelanggan_id.isEmpty() && !poin.isEmpty() )  db.exec(sql, null, true);
                    if( !db.err_msg.equals("") ) {
                        JOptionPane.showMessageDialog( Fedit_penukaran_poin.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                }
                super.setValueAt(val, row_idx, col_idx);
            }
            @Override public void removeRow(int row_idx) {
                String pelanggan_id_was;  String poin;
                pelanggan_id_was = to_db(1, getValueAt(row_idx, 1));
                poin             = to_db(2, getValueAt(row_idx, 2));
                sql = " UPDATE pelanggan SET poin = poin + " +poin+ " WHERE id = " +pelanggan_id_was+ " ;\n" ;
                if( !pelanggan_id_was.isEmpty() && !poin.isEmpty() )  db.exec(sql, null, true);
                if( db.err_msg.equals("") ) super.removeRow(row_idx);
                else JOptionPane.showMessageDialog( Fedit_penukaran_poin.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
            }
        };

        JCdb Cjenis      = new JCdb("pelanggan");
        JCdb Cuser       = new JCdb("SELECT id, username FROM user ORDER BY id");
        db.col_editor    = new JComponent[] { null,       Cjenis,   null,       null,    null,   Cuser  };
        db.col_width     = new int[]        {    0,          150,    100,        400,     150,     100  };
        sql =                           "SELECT id, pelanggan_id,   poin, keterangan, tanggal, user_id   FROM penukaran_poin ORDER BY 1";
    }
}