/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class Fganti_password extends Ftambah {
    JPasswordField Ppassword_old, Ppassword1, Ppassword2;
    public Fganti_password(final Window parent) {
        super(parent, "Ganti Password");
        modul = "Ganti Password \"" +retail.nama+ "\"";

        JLabel Lpassword_old = new JLabel("Password Lama", JLabel.RIGHT);
        Lpassword_old.setBounds(90, 90, 70+100, 35);  panel.add(Lpassword_old);
        Ppassword_old = new JPasswordField(16);
        Ppassword_old.setBounds( 15 + panel.getComponent(3).getX() + panel.getComponent(3).getWidth(), panel.getComponent(3).getY()+3, 200, 29 );  panel.add(Ppassword_old);

        JLabel Lpassword1 = new JLabel("Password Baru", JLabel.RIGHT);  panel.add(Lpassword1);
        Ppassword1 = new JPasswordField(16);  panel.add(Ppassword1);

        JLabel Lpassword2 = new JLabel("Konfirmasi Password Baru", JLabel.RIGHT);  panel.add(Lpassword2);
        Ppassword2 = new JPasswordField(16);  panel.add(Ppassword2);

        mandatory.add(Ppassword_old);    mandatory.add(Ppassword1);    mandatory.add(Ppassword2);
        align_comps();
        Lpassword1.setDisplayedMnemonic( 'B' );    Lpassword2.setDisplayedMnemonic( 'N' );
        setVisible(true);
    }
    @Override Boolean build_sql() {
        //validate first ....
        String err_msg = "";
        String pass1 = new String( Ppassword1.getPassword() );
        String pass2 = new String( Ppassword2.getPassword() );
        if( !pass1.equals(pass2) ) { err_msg += "\nMohon samakan isian \"Password\" dan \"Konfirmasi Password\"!";   Ppassword2.requestFocus(); }
        if( !err_msg.equals("") ) {
            JOptionPane.showMessageDialog( Fganti_password.this, err_msg + "\n\n\n\n" , "Isian harus diperbaiki", JOptionPane.ERROR_MESSAGE);
            return false;
        }
        //validate end  ....
        sql = " UPDATE user SET password=MD5(?) WHERE password=MD5(?) AND id=?" ;    //klo password lama salah, akan muncul error "Maaf, tidak ada yang bisa diupdate" :D Lah, masa password hrs kusimpan di mmory? :)
        String[] params_ = {  new String(Ppassword1.getPassword()), new String(Ppassword_old.getPassword()), String.valueOf(retail.user_id) };
        this.params=params_;
        return true;
    }
}