/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.text.SimpleDateFormat;

public class Fhapus_pembelian extends Fhapus_penjualan {
    public Fhapus_pembelian(final Window parent) {
        super(parent, "Hapus Data Pembelian");
        modul = "Hapus Data Pembelian";
    }
    @Override Boolean build_sql() {
        String date = "'" +new SimpleDateFormat("yyyy-MM-dd").format( Dstop.getDate())+ "'" ;
        sql = " INSERT INTO beli_hapus SELECT * FROM beli WHERE faktur_id IN (SELECT id FROM beli_faktur WHERE tgl_faktur < " +date+ ")  ;\n"
            + " DELETE FROM beli WHERE faktur_id IN (SELECT id FROM beli_faktur WHERE tgl_faktur < " +date+ ")  ;\n"
            + " INSERT INTO beli_backup_hapus SELECT * FROM beli_backup WHERE faktur_backup_id IN (SELECT id FROM beli_faktur_backup WHERE tgl_faktur < " +date+ ")  ;\n"
            + " DELETE FROM beli_backup WHERE faktur_backup_id IN (SELECT id FROM beli_faktur_backup WHERE tgl_faktur < " +date+ ")  ;\n"
            + " INSERT INTO beli_faktur_backup_hapus SELECT * FROM beli_faktur_backup WHERE tgl_faktur < " +date+ "  ;\n"
            + " DELETE FROM beli_faktur_backup WHERE tgl_faktur < " +date+ "  ;\n"
            + " INSERT INTO beli_faktur_hapus SELECT * FROM beli_faktur WHERE tgl_faktur < " +date+ "  ;\n"
            + " DELETE FROM beli_faktur WHERE tgl_faktur < " +date+ "  ;\n"
            + " ALTER TABLE beli_faktur AUTO_INCREMENT = 1  ;\n" ;    //nice way to reset AUTO_INCREMENT :D
        //this.params=null;
        return true;
    }
}