/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.table.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import java.sql.Types;
import java.text.SimpleDateFormat;
import java.util.Date;
import org.jdesktop.swingx.JXDatePicker;

public class Flaporan extends JDialog {
    public JBprint Bprint;  public JBexport_xls Bexport_xls;  public JButton Bsimpan;  public JButton Brefresh;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    JLabel Lgambar;
    public static JTable table;
    int last_selected_row = -13;
    Date Dstart_date;          Date Dstop_date;          String user_selected_name;    int user_selected;
    Date Dstart_date_print;    Date Dstop_date_print;    String user_selected_print;
    //String label = "Penjualan";
    String modul;
    JCdb Cuser;

    JTextField Tdiskon = new JTextField();    JTextField Tppn = new JTextField();    JTextField Tsub_total = new JTextField();    JTextField Ttotal = new JTextField();    JTextField Tdisc_item = new JTextField();
    JLabel Ltotal;  JLabel Lppn;  JLabel Ldiskon;  JLabel Lsub_total;  JLabel Ldisc_item;

    JScrollPane scrollpane;
    Timer timer_title;

    public String get_sql() {
        return   " SELECT f.no_faktur, f.tgl_faktur, brg.code, brg.name, brg.harga_jual, i.banyak, i.diskon, brg.gambar, i.total "
               + "      , f.total, f.ppn, f.diskon AS potongan, f.sub_total "    //ini bs si, tapi lebih manis klo di code ajah:p >> IF(faktur_id=@last_faktur_id, 0, f.total), (@last_faktur_id:=faktur_id)
               + " FROM jual i"
               + " INNER JOIN jual_faktur f ON i.faktur_id=f.id"
               + " LEFT  JOIN barang brg ON i.barang_id=brg.id"
               + " WHERE tgl_faktur BETWEEN '" +new SimpleDateFormat("yyyy-MM-dd").format(this.Dstart_date)+ "' AND '" +new SimpleDateFormat("yyyy-MM-dd").format(this.Dstop_date)+ " 23:59:59' "    //ADDDATE('" +new SimpleDateFormat("yyyy-MM-dd").format(this.Dstop_date)+ "', 1 )
               +         ( user_selected==-13 ? "" : " AND f.user_id = " + user_selected )
               + " ORDER BY i.faktur_id, i.no"    //f.tgl_faktur    //, barang_id
               ;
    }
    public void init_table() {
        db.col_width     = new int[]        {          -140,          -70,           -105, -(scrollpane.getWidth()-5 -140-70-105-60-65-50-0-70  -15),           -60,            -65,           -50,             0,           -70,              0,             0,               0,             0  };   // (-) means not editable:)    //biarin aja kelebaran agar muncul horizontal scrollbar, jelek:p
        db.col_label     = new String[]     {  "no._faktur",    "tanggal",        "kode",                                              "item",       "harga",       "banyak",       "disc.",      "gambar",       "total", "total_faktur",         "ppn", "diskon_faktur",    "sub_total" };    //jgn "tgl._faktur" krn di laporan retur, seharusnya tanggal retur:)
        db.col_type      = new int[]        { Types.VARCHAR,   Types.DATE, Types.VARCHAR,                                       Types.VARCHAR, Types.INTEGER, Types.SMALLINT, Types.INTEGER, Types.VARCHAR, Types.INTEGER,  Types.TINYINT, Types.TINYINT,   Types.TINYINT, Types.INTEGER  };
    }

    public Flaporan(final JFrame parent, final String label) {
        super(parent, retail.app_name + " - Laporan " +label+ "   ::   Petugas: " + retail.nama, true);
        timer_title = new Timer(500, new clock(this));    timer_title.start();
        modul = "Laporan " + label;
        final int row_height = 32;
        setIconImage(retail.icon_app);
//try{
        final JPanel panel = new JPanel();
	panel.setLayout(null);

        getContentPane().add(panel);        
        pack();

        setBounds(GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds()); // setAlwaysOnTop(true);   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); //setSize(800,800); //setExtendedState( getExtendedState()|JFrame.MAXIMIZED_BOTH );
        final JBkeluar Bkeluar = new JBkeluar(this);    panel.add(Bkeluar);

        Lgambar = new JLabel( "[ Gambar ]", JLabel.CENTER );    Lgambar.setForeground(Color.GRAY);
        Lgambar.setBounds( getWidth() - retail.gambar_size - 50, 55, retail.gambar_size, retail.gambar_size ); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        Lgambar.setBorder( BorderFactory.createLoweredBevelBorder() );
        panel.add(Lgambar);

        Ltotal = new JLabel("Total");  Lppn = new JLabel("PPN");  Ldiskon = new JLabel("Potongan");  Lsub_total = new JLabel("Sub Total");  Ldisc_item = new JLabel("Disc. Item");    //supaya di init_table() bisa diganti judul captionnya:p

        table = new JTable(db);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setSurrendersFocusOnKeystroke(true);
        TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(db);
        table.setRowSorter(sorter);
        table.setFillsViewportHeight(true);
        db.column_model  = table.getColumnModel();
        //set height
        table.setRowHeight(row_height);
        JTableHeader header = new JTableHeader( db.column_model ) { @Override public Dimension getPreferredSize() {
                Dimension d = super.getPreferredSize();
                d.height = row_height;
                return d;
        }};
        table.setTableHeader(header);

        scrollpane = new JScrollPane(table);
        scrollpane.setBounds(50, Lgambar.getY(), Lgambar.getX()-50-20, Bkeluar.getY()-Lgambar.getY()-30);    //50, 55, 750, 538
        scrollpane.setBorder( BorderFactory.createRaisedBevelBorder() );
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(16, 16, 60, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), modul ) ) );
        panel.add(scrollpane);

        init_table();
        db.col_editor    = new JComponent[db.col_width.length];
        db.col_precision = new int       [db.col_width.length];
        for( int i=0; i<db.col_width.length; i++ ) {
            db.col_editor[i] = null;
            db.col_precision[i] = 1;
        }
        db.show_table(null,false);

        //jgn ada filter >> kecuali pada printout ada note "data difilter dgn ... " >> JLabel Lcari = new JLabel("F1 - Cari");    Lcari.setDisplayedMnemonic('C');    Lcari.setFont( new Font( "Dialog", Font.BOLD, 12 ));    //"Cari   ( F1 )"

        table.setSelectionMode(0);  //SINGLE_SELECTION
        table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //try{
                if( e.getValueIsAdjusting() ) return;
                int row = table.getSelectedRow();
                if( row<0 ) return;    //if( row<0 || last_selected_row==row ) return;    //supaya ga diulang2 mulu
                row = table.convertRowIndexToModel( row );  //ini berat sehingga lambat saat filter!! .. tp ini tetap diperlukan jika sort enabled:p
                if( last_selected_row==row ) return;    //supaya ga diulang2 mulu
                String gambar_filename = table.getModel().getValueAt( row, 7).toString().trim();
                if( !gambar_filename.equals("") ) {
                    retail.load( Lgambar, gambar_filename );  //if( !retail.load( Lgambar, gambar_filename ).equals("") )
                    if( Lgambar.getIcon()==null ) reset_gambar();    //berarti load imagenya gagal
                } else if( Lgambar.getText()==""  )
                    reset_gambar();
                last_selected_row = row;
                //} catch (Exception ex) {    JOptionPane.showMessageDialog( null, "from listselection\n. Pesan Kesalahan: " + ex, "Gagal baca Variable", JOptionPane.ERROR_MESSAGE); }
            }
        });

        Bprint = new JBprint(this);    //ini harus sesudah init table dan Bsimpan (jika ada) krn constructor JBprint ngebaca component2 tsb.
        Bprint.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-20, Bkeluar.getY(), Bkeluar.getWidth(), Bkeluar.getHeight() );    //Bprint.setBounds( scrollpane.getX() + scrollpane.getWidth() + 20, scrollpane.getY() + scrollpane.getHeight() - Bkeluar.getHeight(), Bkeluar.getWidth(), Bkeluar.getHeight() );
        Bprint.setEnabled(false);
        panel.add(Bprint);
        Bexport_xls = new JBexport_xls(this);    //ini harus sesudah init table dan Bsimpan (jika ada) krn constructor JBexport_xls ngebaca component2 tsb.
        Bexport_xls.setBounds( Bprint.getX()-Bprint.getWidth()-5, Bprint.getY(), Bprint.getWidth(), Bprint.getHeight() );
        Bexport_xls.setEnabled(false);
        panel.add(Bexport_xls);

        JLabel Lstart = new JLabel("Mulai Tanggal");  Lstart.setFont(new Font( Font.DIALOG, Font.PLAIN, 12 ));  Lstart.setForeground( Color.GRAY );  Lstart.setDisplayedMnemonic('M');
        Lstart.setBounds( Lgambar.getX()+2, Lgambar.getY()+Lgambar.getHeight()+25, Lgambar.getWidth(), 15 );  panel.add(Lstart);

        final JXDatePicker Dstart = new JXDatePicker(new Date());  Dstart.setFont(new Font( "Book Antigua", Font.PLAIN, 12 ));   Dstart.getEditor().setMargin( new Insets( 0, 7, 0, 0 ) );
        Dstart.setBounds( Lgambar.getX(), Lstart.getY()+Lstart.getHeight(), Lgambar.getWidth(), 29 );
        Dstart.setFormats(new SimpleDateFormat("dd-MM-yyyy"));    //karakter "-0" jelek (lengket) dengan font Kartika    //penambahan spasi di depan malah bikin kemungkinan gagal kalo diketik manual " dd-MM-yyyy"
        Dstart.setLinkDay(new Date(), "Hari ini: {0, date, EEEE, dd-MM-yyyy}");    //ini tanpa koma?:) >> full
        Lstart.setLabelFor(Dstart);
        panel.add(Dstart);


        JLabel Lstop = new JLabel("sampai dengan Tanggal");  Lstop.setFont(Lstart.getFont());  Lstop.setForeground( Lstart.getForeground() );  Lstop.setDisplayedMnemonic('S');
        Lstop.setBounds( Lstart.getX(), Dstart.getY()+Dstart.getHeight()+7, Dstart.getWidth(), Lstart.getHeight() );  panel.add(Lstop);

        final JXDatePicker Dstop = new JXDatePicker(new Date());  Dstop.setFont(Dstart.getFont());   Dstop.getEditor().setMargin( Dstart.getEditor().getMargin() );
        Dstop.setBounds( Lgambar.getX(), Lstop.getY()+Lstop.getHeight(), Dstart.getWidth(), Dstart.getHeight() );
        Dstop.setFormats(Dstart.getFormats());
        Dstop.setLinkDay(Dstart.getLinkDay());
        Lstop.setLabelFor(Dstop);
        panel.add(Dstop);

        final JButton Blihat = new JButton( "F5 - lihat data", retail.icon_lihat );
        int next_y = Dstop.getY()+Dstop.getHeight();
        user_selected = retail.user_id;    user_selected_name = retail.nama;
        //filter_user = " AND f.user_id = " +retail.user_id;

        if( retail.hak_akses.indexOf("'Edit User'") >= 0 ) {    //provide all user
            JLabel Luser = new JLabel("Petugas");       Lstop.setFont(Lstart.getFont());  Luser.setBounds( Lstop.getX(), next_y+7, Dstop.getWidth(), Lstop.getHeight() );  Luser.setForeground( Lstart.getForeground() );  Luser.setDisplayedMnemonic('U');  panel.add(Luser);
            Cuser = new JCdb( "SELECT id, nama FROM user ORDER BY 2" );        Cuser.setBounds( Lgambar.getX(), Luser.getY()+Luser.getHeight(), Dstop.getWidth(), Dstop.getHeight() );  Luser.setLabelFor(Cuser);  panel.add(Cuser);
            Cuser.addItem( new jcdb_item( -13, "[  Semua  ]" ) );    //ga formil kayaknya klo pake titik2 >> .....
            Cuser.addItemListener(new ItemListener() { public void itemStateChanged(ItemEvent e) {
                Blihat.setEnabled(true);
                user_selected      = ((jcdb_item)e.getItem()).get_id();
                user_selected_name = ((jcdb_item)e.getItem()).toString();
                //filter_user = ( user_id==-13 ? "" : " AND f.user_id = " +user_id ) ;
            }});
            Cuser.setSelectedIndex( Cuser.getItemCount()-1 );    //Cuser.setSelectedIndex( Cuser.my_index_of(retail.nama) );
            next_y = Cuser.getY()+Cuser.getHeight();
        }
        /* else {    //provide only this user
            Cuser = new JCdb("");
            Cuser.addItem( new jcdb_item( retail.user_id, "[  Semua .....  ]" ) );
            //Cmodul.setSelectedIndex(0);
            Cuser.setSelectedIndex( Cuser.my_index_of(retail.nama) );
        }
        */

        Blihat.setAlignmentX( Bkeluar.getAlignmentX() );    Blihat.setIconTextGap( Bkeluar.getIconTextGap() );
        Blihat.setBounds( Lgambar.getX()+13-13, next_y+15, Dstart.getWidth()-2*0 - 38-0, Bkeluar.getHeight() );
        Blihat.setMnemonic('L');  Blihat.addFocusListener(retail.onHover);
        panel.add(Blihat);

        Brefresh = new JButton( "", retail.icon_refresh );
        Brefresh.setAlignmentX( Bkeluar.getAlignmentX() );    Brefresh.setIconTextGap( Bkeluar.getIconTextGap() );
        Brefresh.setBounds( Blihat.getX()+Blihat.getWidth() + 0, Blihat.getY(), 38, Bkeluar.getHeight() );
        Brefresh.setMnemonic('R');  Brefresh.addFocusListener(retail.onHover);
        Brefresh.setToolTipText("F5 - Refresh");
        panel.add(Brefresh);


        /* ini ga aktif jika editor diedit manual dan diEnter:(, gara2 enter dipakai di retail.addEnterToTraversalKeys(this); di bawah
        ActionListener date_listener = new ActionListener() { public void actionPerformed(ActionEvent e) {
            //if( !Dstart.COMMIT_KEY.equals(e.getActionCommand()) ) return; 
            Blihat.setEnabled(true);
	}};
        Dstart.addActionListener(date_listener);        //ini tetap aja ga manggil listener >>  Dstart.setDate(new Date());  //new java.sql.Date( System.currentTimeMillis() )
        Dstop.addActionListener(date_listener);
        */
        DocumentListener date_listener = new DocumentListener() {
            public void changedUpdate(DocumentEvent e) {    //ini emang baca Dstart.getDate() biar datenya tervalidasi dulu (otherwise u did ur own validation:) ), maka user emang perlu press enter dulu baru Blihat enable:p
                Date Dstart_temp = Dstart.getDate();    Date Dstop_temp = Dstop.getDate();
                if( Dstart_temp==Dstart_date && Dstop_temp==Dstop_date ) return;    //if( temp_filter_tgl_faktur.equals( filter_tgl_faktur ) ) return;    //ga ngefek, masa dia beraksi dua kali ?! bahkan hanya saat focus berubah?! :p >> if( !Dstart.COMMIT_KEY.equals("datePickerCommit") ) return;    //if( !Dstart.COMMIT_KEY.equals(e.getActionCommand()) ) return;    //Lgambar.setText( Lgambar.getText() + "1");
                Boolean Dstop_is_changed = Dstart_temp==Dstart_date;
                Dstart_date = Dstart_temp;    Dstop_date = Dstop_temp;
                if( Dstop_temp.before(Dstart_temp) )  {
                    JOptionPane.showMessageDialog( Flaporan.this, "\nMaaf, \"Tanggal Mulai\" tidak boleh melampaui \"Tanggal Akhir\"!\n\n\n\n\n", "Rentang tanggal tidak sesuai", JOptionPane.ERROR_MESSAGE);
                    if(Dstop_is_changed) Dstop.requestFocus();    else Dstart.requestFocus();    //Dstop.getEditor().selectAll() does not work    //requestFocus() jg memanggil listener ini krn sepertinya itu dilakukan datepicker:p    //seharusnya si ga boleh exit dari control ini:p
                    return;
                }
                Blihat.setEnabled(true);
            }
            public void removeUpdate(DocumentEvent e) { changedUpdate(e); }
            public void insertUpdate(DocumentEvent e) { changedUpdate(e); }
        };
        Dstart.getEditor().getDocument().addDocumentListener(date_listener);
        Dstop.getEditor().getDocument().addDocumentListener(date_listener);

        Dstart_date = new Date();  Dstop_date=new Date();    //initiate dulu biar bisa data bisa langsung muncul saat form dibuka .... ini krn gue kagak tau mentrigger Dstart nya:p
        Brefresh.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            Blihat.setEnabled(false);
            //show the data
            db.exec( get_sql(), null, true );
            if( !db.err_msg.equals("") ) { Blihat.setEnabled(true);  JOptionPane.showMessageDialog( Flaporan.this, db.err_msg+ "\n\n\n\n\n", "Pembacaan Data "+label+" Gagal", JOptionPane.ERROR_MESSAGE);    return; }    //don't close:p >> error("Pembacaan Data Penjualan");
            db.rows.clear();
            Tdisc_item.setText("");  Tsub_total.setText("");  Tdiskon.setText("");  Tppn.setText("");  Ttotal.setText("");    //perlu klo db.rs.size() <= 0 :p
            if( db.rs.size() <= 0 )      {
                reset_gambar();               //perlu klo db.rs.size() <= 0 :p
                db.fireTableDataChanged();    //perlu klo db.rs.size() <= 0 :p
                JOptionPane.showMessageDialog( Flaporan.this, "\nMaaf, Data "+label+" tidak ditemukan!\n\n\n\n\n", "Data tidak ditemukan", JOptionPane.ERROR_MESSAGE);
                Dstart.requestFocus();
                return;
            }
            try {
                Object[] rs_row = new Object[db.col_width.length];
                int[] col_type  = new int   [db.col_width.length];
                String last_no_faktur = "";  long disc_item=0;  long sub_total_faktur=0;  long potongan=0;  long ppn=0;  long total_faktur=0;
                byte disc_sign        = (byte) -1 ;
                while( db.rs.next() ) {
                    for( int i=0; i<db.col_width.length; i++ ) {  //klo ga gini, kebanyakan try{} ntar
                        rs_row[i] = db.rs.getObject(i+1);
                        if(col_type[i]==0) col_type[i] = db.metaData.getColumnType(i+1);
                    }
                    db.addRow(rs_row,col_type);
                    //calculating the summary
                    disc_item += db.rs.getLong("diskon") ;    // retail.round( (long) db.rs.getInt(5) * db.rs.getInt("diskon") * db.rs.getInt(6) , 100 ) ;    //ada si resiko kecil banget jika pembulatannya pas tengah2:p ... tp masa ada harga kelipatan di bawah 100?! ... ada aja si klo di supermarket:D
                    if( !last_no_faktur.equals( db.rs.getString(1) ) || db.rs.getLong(9)==-1 ) {    //bisa berisi no_faktur atau faktur.id
                        last_no_faktur    = db.rs.getString(1);
                        sub_total_faktur += db.rs.getLong(13) ;
                        potongan         += db.rs.getLong(12) ;    //db.rs.getLong(9)==-1 ? db.rs.getLong(12)    : retail.round( (long) db.rs.getLong(13) * db.rs.getLong(12) , 100 ) ;    //db.rs.getInt(9)==-1  utk laporan kas:p  //ada si resiko kecil banget jika pembulatannya pas tengah2:p ... tp masa ada harga kelipatan di bawah 100?! ... ada aja si klo di supermarket:D
                        ppn              += db.rs.getLong(9)==-1 ? db.rs.getLong("ppn") : retail.round( (long) (db.rs.getLong(13)+db.rs.getLong(12)) * db.rs.getLong("ppn") , 100 ) ;    //ada si resiko kecil banget jika pembulatannya pas tengah2:p ... tp masa ada harga kelipatan di bawah 100?! ... ada aja si klo di supermarket:D
                        total_faktur     += db.rs.getLong(10) ;
//JOptionPane.showMessageDialog( Flaporan.this, "\nlast_no_faktur=" + last_no_faktur + "\ndb.rs.getInt(10)=" + db.rs.getInt(10) + "\ntotal_faktur=" + total_faktur + "\ntotal_faktur=" + total_faktur , "Pembacaan Data "+label+" Gagal", JOptionPane.ERROR_MESSAGE);
                        if( db.rs.getLong(9)==-1 ) disc_sign = (byte) 1 ;
                    } else if( Ltotal.getText().equals("Laba Rugi") )
                        total_faktur     += db.rs.getLong(10) ;    //cappe deeeh:)
                }
                db.rs.close();

//JOptionPane.showMessageDialog( Flaporan.this, "\ndb.getRowCount()=" + db.getRowCount() + "\nsql=" + get_sql(), "Pembacaan Data "+label+" Gagal", JOptionPane.ERROR_MESSAGE);

                //print the summary
                Tdisc_item.setText ( String.format("%,d", disc_sign*disc_item     ) );
                Tsub_total.setText ( String.format("%,d", sub_total_faktur ) );
                Tdiskon.setText    ( String.format("%,d", (Ldiskon.getText().equals("Potongan") ? 1 : -1) * potongan      ) );
                Tppn.setText       ( String.format("%,d", ppn              ) );
                Ttotal.setText     ( String.format("%,d", total_faktur     ) );

                Dstart_date_print = Dstart_date;    Dstop_date_print = Dstop_date;    user_selected_print = user_selected_name;
                last_selected_row = -1;    //ngumpanin ListSelectionListener() ... agar tetap load_gambar
                db.fireTableDataChanged();    //perlu di sini agar yg bawah ini kagak error
                table.setRowSelectionInterval(table.getRowCount()-1,table.getRowCount()-1);    table.setColumnSelectionInterval(table.getColumnCount()-1,table.getColumnCount()-1);    table.scrollRectToVisible( table.getCellRect( table.getSelectedRow(), table.getSelectedColumn(), true ) );    //load_gambar( rs_row[6].toString() );
                Bprint.setEnabled(true);  Bexport_xls.setEnabled(true);
                table.requestFocus();
            } catch (Exception ex) {
                db.err_msg += "\nMaaf, Data \""+label+"\" gagal dibaca!\n\n\n(" + ex + ")";
                JOptionPane.showMessageDialog( Flaporan.this, db.err_msg+ "\n\n\n\n\n", "Pembacaan Data "+label+" Gagal", JOptionPane.ERROR_MESSAGE);
                Blihat.setEnabled(true);
            }
        }});

        Blihat.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                Brefresh.doClick();
        }});

        final JPopupMenu popup = new JPopupMenu();
        panel.add(popup);
        JMenuItem menu_refresh = new JMenuItem("F5 - Refresh", retail.icon_refresh);
        menu_refresh.setMnemonic(KeyEvent.VK_R);
        popup.add(menu_refresh);
        menu_refresh.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                Brefresh.doClick();
        }});
        table.addMouseListener( new MouseListener() {
            public void mousePressed(MouseEvent e) {
                if( !( e.getComponent() instanceof JTable && (e.getModifiers() & InputEvent.BUTTON3_MASK ) == InputEvent.BUTTON3_MASK ) ) return;
                JTable table = (JTable)e.getComponent();
                int row = table.rowAtPoint(e.getPoint());
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //doesn't work >> table.transferFocus();  //post update jika icon close diklik atau ALT-F4 :)  //ga mo cerewet ah:)) >> if( !db.err_msg.equals("") ) { error("Update Data Gagal");   return; }
                table.setRowSelectionInterval(row, row);
                popup.show(table, e.getX(), e.getY());   //table.setComponentPopupMenu(popup);  //ga listening klo di klik kanan ulang di tempat lain :p
            }
            public void mouseClicked(MouseEvent e) {}    public void mouseEntered(MouseEvent e) {}    public void mouseExited(MouseEvent e) {}    public void mouseReleased(MouseEvent e) {}
        });


        Ltotal.setFont(Lstart.getFont());
        Ltotal.setBounds( Lstart.getX(), scrollpane.getY()+scrollpane.getHeight()-Dstart.getHeight(), 62, Dstart.getHeight() );  panel.add(Ltotal);
        Ttotal.setEditable(false);  Ttotal.setBackground(retail.disabled_color);  Ttotal.setFont( new Font( "Kartika", Font.BOLD, 20 ) );  Ttotal.setHorizontalAlignment(JTextField.RIGHT);  Ttotal.setMargin( Dstart.getEditor().getMargin() );
        Ttotal.setBounds( Ltotal.getX()+Ltotal.getWidth(), Ltotal.getY(), Lstart.getWidth()-Ltotal.getWidth(), Ltotal.getHeight() );  panel.add(Ttotal);

        Tppn.setEditable(false);  Tppn.setBackground(Ttotal.getBackground());  Tppn.setFont(Ttotal.getFont());  Tppn.setHorizontalAlignment(JTextField.RIGHT);  Tppn.setMargin( Ttotal.getMargin() );
        Tppn.setBounds( Ttotal.getX(), Ltotal.getY()-Ttotal.getHeight()-0, Ttotal.getWidth(), Ttotal.getHeight() );  panel.add(Tppn);
        Lppn.setFont(Lstart.getFont());
        Lppn.setBounds( Lstart.getX(), Tppn.getY(), Lstart.getWidth()-Ttotal.getWidth(), Ttotal.getHeight() );  panel.add(Lppn);

        Tdiskon.setEditable(false);  Tdiskon.setBackground(Ttotal.getBackground());  Tdiskon.setFont(Ttotal.getFont());  Tdiskon.setHorizontalAlignment(JTextField.RIGHT);  Tdiskon.setMargin( Ttotal.getMargin() );
        Tdiskon.setBounds( Tppn.getX(), Lppn.getY()-Tppn.getHeight()-0, Tppn.getWidth(), Tppn.getHeight() );  panel.add(Tdiskon);
        Ldiskon.setFont(Ltotal.getFont());
        Ldiskon.setBounds( Lstart.getX(), Tdiskon.getY(), Lstart.getWidth()-Ttotal.getWidth(), Ttotal.getHeight() );  panel.add(Ldiskon);
 
        Tsub_total.setEditable(false);  Tsub_total.setBackground(Ttotal.getBackground());  Tsub_total.setFont(Ttotal.getFont());  Tsub_total.setHorizontalAlignment(JTextField.RIGHT);  Tsub_total.setMargin( Ttotal.getMargin() );
        Tsub_total.setBounds( Tdiskon.getX(), Ldiskon.getY()-Tdiskon.getHeight()-0, Tdiskon.getWidth(), Tdiskon.getHeight() );  panel.add(Tsub_total);
        Lsub_total.setFont(Ltotal.getFont());
        Lsub_total.setBounds( Lstart.getX(), Tsub_total.getY(), Lstart.getWidth()-Ttotal.getWidth(), Ttotal.getHeight() );  panel.add(Lsub_total);

        Tdisc_item.setEditable(false);  Tdisc_item.setBackground(Ttotal.getBackground());  Tdisc_item.setFont(Ttotal.getFont());  Tdisc_item.setHorizontalAlignment(JTextField.RIGHT);  Tdisc_item.setMargin( Ttotal.getMargin() );
        Tdisc_item.setBounds( Tsub_total.getX(), Lsub_total.getY()-Tsub_total.getHeight()-0, Tsub_total.getWidth(), Tsub_total.getHeight() );  panel.add(Tdisc_item);
        Ldisc_item.setFont(Ltotal.getFont());
        Ldisc_item.setBounds( Lstart.getX(), Tdisc_item.getY(), Lstart.getWidth()-Ttotal.getWidth(), Ttotal.getHeight() );  panel.add(Ldisc_item);


        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                close();
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  
            @Override public void windowOpened(WindowEvent e) {    //Invoked the first time a window is made visible.
                Brefresh.doClick();    //hehe
                if( table.getRowCount()>0 )  table.setColumnSelectionInterval(0,0);    //sudah di Brefresh.doClick() >> table.requestFocus();    table.setRowSelectionInterval(0,0);
                else                         Dstart.requestFocus();
            }
            @Override public void windowClosing(WindowEvent e) {
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update jika icon close diklik atau ALT-F4 :)  //ga mo cerewet ah:)) >> if( !db.err_msg.equals("") ) { error("Update Data Gagal");   return; }
                Bkeluar.doClick();
            }
        });

        retail.removeTitleButtons(this, onClose);
        //if( retail.hak_akses.indexOf("'Edit User'") >= 0 ) //ga bs krn dia langsung eksekusi saat diklik :( >> Cuser.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {    Blihat.doClick();    }});
        //jadi ga bisa edit JCombo:((  retail.addUpDownToTraversalKeys(this);
        retail.addEnterToTraversalKeys(this);    //ini bikin JDatePicker editor actionListener tidak aktif jika diedit manual lalu di[enter].
        //retail.addLeftRightToTraversalKeys(this);

        //Dstart.requestFocus();
        //Brefresh.doClick();
        //setVisible(true);
        //} catch (Exception e) {            JOptionPane.showMessageDialog( null, "create form gagal: " + e, "Pembacaan Data Barang", JOptionPane.ERROR_MESSAGE);     close();   return;  }
    }
    void reset_gambar() {
        if( Lgambar.getText()!="") return;
        Lgambar.setIcon(null);
        Lgambar.setText( "[ Gambar ]" );
    }
    void close() {
        timer_title.stop();    //take my whole day to investigate the problem he create:p
        try { db.rs.close(); } catch (Exception e) {}
        db.close(); table.setRowSorter(null);  //sorter=null;  //aneh aja ... tanpa ini, jika row diubah urutannya trus didelete, lalu ditutup-buka lagi, terjadi error saat fireTableRowsInserted(getRowCount()-1, getRowCount()-1);
        dispose();
    }



    //to print
    public Object[][] title_header() {
        Object[][] title_header = {
              { modul.toUpperCase() }
            , {"Tanggal"   , ":  " + new SimpleDateFormat("EEEE, d MMMM yyyy").format( Dstart_date_print ) + "  s.d.  " + new SimpleDateFormat("EEEE, d MMMM yyyy").format( Dstop_date_print ) }
            , {"Petugas"   , ":  " + user_selected_print }
            };
        return title_header;
    }
    public Object[][] table_summary() {
        Object[][] table_summary = {
              {"Disc. Item"     , ":  Rp. ", Tdisc_item.getText() }
            , {"Sub Total"      , ":  Rp. ", Tsub_total.getText() }
            , {"Potongan"       , ":  Rp. ", Tdiskon.getText()    }
            , {"PPN"            , ":  Rp. ", Tppn.getText()       }
            , {Ltotal.getText() , ":  Rp. ", Ttotal.getText()     }
            };
        return table_summary;
    }
}