/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class Ftambah_kas extends Ftambah {
    JComboBox Cjenis;  JTextField Tjumlah;  JTextField Tketerangan;
    public Ftambah_kas(final Window parent) {
        super(parent, "Kas Masuk/Keluar");
        modul = "Input Kas Masuk/Keluar";

        JLabel Ljenis = new JLabel("Transaksi", JLabel.LEFT);
        Ljenis.setBounds(90, 90, 70, 35);  panel.add(Ljenis);
        Cjenis = new JComboBox( new String[] {" Kas Masuk"," Kas Keluar"} );
        Cjenis.setSelectedIndex(1);
        Cjenis.setBounds( 15 + panel.getComponent(3).getX() + panel.getComponent(3).getWidth(), panel.getComponent(3).getY()+3, 200, 29 );  panel.add(Cjenis);

        JLabel Ljumlah = new JLabel("Jumlah (Rp)", JLabel.LEFT);  panel.add(Ljumlah);
        Tjumlah = new JTextField(9);  panel.add(Tjumlah);    Tjumlah.setName("enable_sign");

        JLabel Lketerangan = new JLabel("Keterangan", JLabel.LEFT);  panel.add(Lketerangan);
        Tketerangan = new JTextField(255);  panel.add(Tketerangan);

        mandatory.add(Tjumlah);
        comp_number.add(Tjumlah);
        align_comps();
        Tketerangan.setSize( new Dimension(500, Cjenis.getHeight()) );

        Tjumlah.requestFocus();
        setVisible(true);
    }
    @Override Boolean build_sql() {
        sql = " INSERT INTO kas (             id         , masuk_keluar, amount, keterangan,  user_id, terminal ) "
                       + " SELECT IFNULL( MAX(id), 0) + 1,       ?     ,    ?  ,      ?    ,     ?   ,     ?      FROM kas" ;
        byte masuk_keluar = Cjenis.getSelectedIndex()==0?(byte)1:(byte)-1;
        byte terminal = 0;    try { terminal = java.net.InetAddress.getLocalHost().getAddress()[3]; } catch(java.net.UnknownHostException e) {}
        String[] params_ = {  String.valueOf(masuk_keluar), String.valueOf( masuk_keluar * Math.abs( Integer.valueOf(Tjumlah.getText().replace(retail.digit_separator,"")) ) ), Tketerangan.getText(), String.valueOf(retail.user_id), String.valueOf(terminal) };
        this.params=params_;
        return true;
    }
}