/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class Ftambah_user extends JDialog {
    public JButton Bsimpan;    public JButton Bkosongkan;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    public Ftambah_user(final JFrame parent) {
        super(parent, retail.app_name + " - Tambah User" + "   ::   Petugas: " + retail.nama, true);
        final String modul = "Tambah Data User";
        String err_msg = "";
        setIconImage(retail.icon_app);
        setMinimumSize( new Dimension(850, 650) );

        final JPanel panel = new JPanel();
	panel.setLayout(null);
        //panel.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createLoweredBevelBorder() , BorderFactory.createRaisedBevelBorder() ) );
        //panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(13, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Tambah User", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Trebuchet MS", Font.PLAIN, 12 )) ) );
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(26, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Tambah User" ) ) );

        JLabel Lusername = new JLabel("Username", JLabel.RIGHT);
        Lusername.setBounds(60, 80, 150, 35);  panel.add(Lusername);
        final JTextField Tusername = new JTextField();  Tusername.setMinimumSize( new Dimension(10, 1) ); //ini hanya utk ngebatasi maksimum karakter:p
        Tusername.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 200, 29 );  panel.add(Tusername);

        JLabel Lpassword1 = new JLabel("Password", JLabel.RIGHT);  panel.add(Lpassword1);
        final JPasswordField Ppassword1 = new JPasswordField();  Ppassword1.setMinimumSize( new Dimension(16,1) );  panel.add(Ppassword1);

        JLabel Lpassword2 = new JLabel("Konfirmasi Password", JLabel.RIGHT);  panel.add(Lpassword2);
        final JPasswordField Ppassword2 = new JPasswordField();  Ppassword2.setMinimumSize( new Dimension(16, 1) );  panel.add(Ppassword2);

        JLabel Lnama = new JLabel("Nama Lengkap", JLabel.RIGHT);  panel.add(Lnama);
        final JTextField Tnama = new JTextField(40);  Tnama.setMinimumSize( new Dimension(50, 1) );  panel.add(Tnama);

        JLabel Lno_hp = new JLabel("No. HP", JLabel.RIGHT);  panel.add(Lno_hp);
        final JTextField Tno_hp = new JTextField(40);  Tno_hp.setMinimumSize( new Dimension(50, 1) );  panel.add(Tno_hp);

        JLabel Lno_telp = new JLabel("No. Telp.", JLabel.RIGHT);  panel.add(Lno_telp);
        final JTextField Tno_telp = new JTextField(40);  Tno_telp.setMinimumSize( new Dimension(50, 1) );  panel.add(Tno_telp);

        JLabel Lalamat = new JLabel("Alamat", JLabel.RIGHT);  panel.add(Lalamat);
        final JTextField Talamat = new JTextField(80);  Talamat.setMinimumSize( new Dimension(127, 1) );  panel.add(Talamat);

        JLabel Lnip = new JLabel("No. Induk Pegawai", JLabel.RIGHT);  panel.add(Lnip);
        final JTextField Tnip = new JTextField(40);  Tnip.setMinimumSize( new Dimension(50, 1) );  panel.add(Tnip);

        JLabel Ljabatan = new JLabel("Jabatan", JLabel.RIGHT);  panel.add(Ljabatan);
        final JTextField Tjabatan = new JTextField(40);  Tjabatan.setMinimumSize( new Dimension(50, 1) );  panel.add(Tjabatan);

        JLabel Lgrup = new JLabel("Grup", JLabel.RIGHT);  panel.add(Lgrup);
        final JComboBox Cgrup = new JCdb("user_grup");
        err_msg += db.err_msg;
        panel.add(Cgrup);

        final JBkeluar Bkeluar = new JBkeluar(this);

        Bkosongkan = new JButton("F5 - kosongkan", retail.icon_reset);
        Bkosongkan.setAlignmentX( Bkeluar.getAlignmentX() );
        Bkosongkan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bkosongkan.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-30, Bkeluar.getY(), Bkeluar.getWidth()+30, Bkeluar.getHeight() );//java default
        Bkosongkan.setMnemonic('O');  Bkosongkan.addFocusListener(retail.onHover);
        Bkosongkan.setEnabled(false);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Bkosongkan.getAlignmentX() );
        Bsimpan.setIconTextGap( Bkosongkan.getIconTextGap() );
        Bsimpan.setBounds( Bkosongkan.getX()-Bkosongkan.getWidth(), Bkosongkan.getY(), Bkosongkan.getWidth()-10, Bkosongkan.getHeight() );//java default
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Bkosongkan);
        panel.add(Bkeluar);

        getContentPane().add(panel);
        pack();
        //setSize(400, 280);  //harus sesudah pack():p
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL); //DOCUMENT_MODAL
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE); //setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);     //setLocationRelativeTo(parent);

        //the events ....
        /*
        FocusListener password_match = new FocusListener() {
            public void focusLost(FocusEvent e) {
                if( e.getOppositeComponent() != null ) if( e.getOppositeComponent().getClass().getName() == ((Component)e.getSource()).getClass().getName() ) return; //jika pindah ke kolom password yg lain.
                String pass1 = new String( Ppassword1.getPassword() );
                String pass2 = new String( Ppassword2.getPassword() );
                if( !pass1.equals(pass2) && !pass1.equals("") && !pass2.equals("") ) { //if( !Ppassword1.getPassword().equals( Ppassword2.getPassword() ) && !((JPasswordField)e.getSource()).getPassword().equals("") ) {
                    JOptionPane.showMessageDialog( Ftambah_user.this, "Mohon samakan isian \"Password\" dan \"Konfirmasi Password\"", "Password harus sama", JOptionPane.ERROR_MESSAGE);
                    ((JPasswordField)e.getSource()).requestFocus();
                    //TIDAK BISA NYETOP EVENT2 BERIKUTNYA (misal: klik simpan)!!!
                }
            }
            public void focusGained(FocusEvent e) {}
        };
        Ppassword1.addFocusListener(password_match);
        Ppassword2.addFocusListener(password_match);
        */

        ItemListener enable_on_change_combo = new ItemListener() { public void itemStateChanged(ItemEvent e) {
            Bsimpan.setEnabled(true);
            Bkosongkan.setEnabled(true);
        }};

        int ci=0;
        for( Component comp : panel.getComponents() ) {
            if( comp instanceof JTextField || comp instanceof JPasswordField ) {
                JTextComponent tc = (JTextComponent)comp;
                AbstractDocument doc = (AbstractDocument) tc.getDocument();
                doc.putProperty("tombol_to_enable", new JButton[]{Bsimpan, Bkosongkan} );
                doc.setDocumentFilter(new PatternFilter( ".{0," + (int)comp.getMinimumSize().getWidth() + "}" ));
                doc.addDocumentListener(retail.enable_on_change);
                tc.setMargin( new Insets( 0, 7, 0, 0 ) );
            }
            if( comp instanceof JComboBox ) ((JComboBox)comp).addItemListener(enable_on_change_combo);
            if( comp instanceof JLabel || comp instanceof JTextField || comp instanceof JPasswordField || comp instanceof JComboBox ) {
                ci = panel.getComponentZOrder(comp);
                if( ci>=2 ) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );

                if( comp instanceof JLabel ) { //set agar field dapat requestfocus saat labelnya diakses via "mnemonic" key...
                    JLabel label = (JLabel)comp;
                    label.setLabelFor( panel.getComponent(ci+1) );
                    if( label.getText().equals( "No. HP" ) ) label.setDisplayedMnemonic( 'H' );
                    else if( label.getText().equals( "No. Telp." ) ) label.setDisplayedMnemonic( 'T' );
                    else if( label.getText().equals( "No. Induk Pegawai" ) ) label.setDisplayedMnemonic( 'I' );
                    else if( label.getText().equals( "Konfirmasi Password" ) ) label.setDisplayedMnemonic( 'F' );
                    else label.setDisplayedMnemonic( label.getText().charAt(0) );
                }
            }
        }


        //customize size ...
        Tusername.setSize( new Dimension(130, Tusername.getHeight()) );
        Ppassword1.setSize(Tusername.getSize());
        Ppassword2.setSize(Tusername.getSize());
        Cgrup.setSize(Tusername.getSize());
        Tnama.setSize( new Dimension(300, Tusername.getHeight()) );
        Talamat.setSize( new Dimension(500, Tusername.getHeight()) );

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            //validate first ....
            if( retail.empty( new JTextComponent[]{ Tusername, Ppassword1, Ppassword2, Tnama } )) return;

            String err_msg = "";
            String pass1 = new String( Ppassword1.getPassword() );
            String pass2 = new String( Ppassword2.getPassword() );
            if( !pass1.equals(pass2) ) { err_msg += "\nMohon samakan isian \"Password\" dan \"Konfirmasi Password\"!";   Ppassword2.requestFocus(); }

            if( !err_msg.equals("") ) {
                JOptionPane.showMessageDialog( Ftambah_user.this, err_msg + "\n\n\n\n" , "Isian harus diperbaiki", JOptionPane.ERROR_MESSAGE);
                return;
            }
            //validate end  ....

            String sql = " INSERT INTO user (             id         , username, password, nama, no_hp, no_telp, alamat, nip, jabatan, grup_id) "
                       + " SELECT             IFNULL( MAX(id), 0) + 1,     ?   ,  MD5(?) ,   ? ,   ?  ,    ?   ,    ?  ,  ? ,     ?  ,    ?   FROM user" ;
            String[] params = { Tusername.getText(), new String(Ppassword1.getPassword()), Tnama.getText(), Tno_hp.getText(), Tno_telp.getText(), Talamat.getText(), Tnip.getText(), Tjabatan.getText(), String.valueOf( ((jcdb_item)Cgrup.getSelectedItem()).get_id() ) };
            db.exec(sql, params, true);
            if( db.err_msg.equals("") ) Bkosongkan.doClick();
            else JOptionPane.showMessageDialog( Ftambah_user.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
        }});

        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                for(Component comp : panel.getComponents()) {
                    if( comp instanceof JTextField || comp instanceof JPasswordField ) ((JTextComponent)comp).setText("");
                    if( comp instanceof JComboBox ) ((JComboBox)comp).setSelectedIndex(0);
                }
                Bkosongkan.setEnabled(false);    Bsimpan.setEnabled(false);
                Tusername.requestFocus();
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { close(); return; }    //if( ((Window)SwingUtilities.windowForComponent((Component)e.getSource())).Bsimpan.isEnabled() ) {  //getAncestorNamed("Bsimpan", e.getSource())
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  
            @Override
            public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
            }
        });

        retail.removeTitleButtons(this, onClose);
        //jadi ga bisa edit JCombo:((  retail.addUpDownToTraversalKeys(this);
        retail.addEnterToTraversalKeys(this);
        //retail.addLeftRightToTraversalKeys(this);

        if( !err_msg.equals("") ) {
            JOptionPane.showMessageDialog( this, err_msg, "Inisialisasi Data Gagal", JOptionPane.ERROR_MESSAGE);
            Bkeluar.doClick();
        } else
            setVisible(true);

    }
    void close() {
        db.close(); dispose();
    }
}