/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.table.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
//import javax.swing.event.TableModelEvent;
import java.io.File;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

public class Fedit_barang extends JDialog {
    //must be public to let retail.click_button() ...
    public JButton Bambil_gambar, Bhapus;    public JBprint Bprint_barcode, Bprint_label_rak;      public JBprint_auto Bprint;  public JBexport_xls Bexport_xls;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    public JLabel Lgambar;    //agar bisa jadi tempat pengalihan di retail.post_barcode() :p
    JLabel Lrangkap;
    JMenuItem menu_hapus_gambar;
    JButton Bganti_gambar, Bhapus_gambar;
    public JTable table;    public JMenuItem menu_tambah = null;
    Boolean summary = retail.hak_akses.indexOf("'Summary di Fitur Barang'") >= 0;
    JTextField Taset, Tmodal, Tstok, Titem;  //ActionListener summary_actionListener;
    JComboBox Ccopies;
    Boolean printer_barcode   = retail.convert_null(retail.setting.get("Aktifkan Printer Barcode")).toLowerCase().equals("ya");
    Boolean printer_label_rak = retail.convert_null(retail.setting.get("Aktifkan Printer Label Rak")).toLowerCase().equals("ya");
    int last_selected_row = -13;
    public Fedit_barang(final Window parent) {    //JFrame parent
        this(parent, "");
    }
    public Fedit_barang(final Window parent, final String barcode_init) {    //JFrame parent
        super(parent, retail.app_name + " - Edit Barang" + "   ::   Petugas: " + retail.nama, Dialog.ModalityType.APPLICATION_MODAL);
        final String modul = "Edit Data Barang";
        final int row_height = 32;
        setIconImage(retail.icon_app);

        final JPanel panel = new JPanel();
	panel.setLayout(null);

        if(summary) table = new JTable(db){
                                               @Override public void sorterChanged(javax.swing.event.RowSorterEvent e) {
                                                    super.sorterChanged(e);    //ni klo mau pake no index di kiri yg tidak ingin disort:) >> int indexOfNoColumn = 0;    for (int i = 0; i < table.getRowCount(); i++)  table.setValueAt(i + 1, i, indexOfNoColumn);     //jgn lupa juga >> sorter.setSortable(int column, boolean sortable);
                                                    if( e.getType() == javax.swing.event.RowSorterEvent.Type.SORTED ) refresh_summary();
                                               }
                                               /*  ini maksudnya utk pertama tampil tapi tetap error juga
                                               @Override public void tableChanged(javax.swing.event.TableModelEvent e) {
                                                   super.tableChanged(e);    if( this.isVisible() ) refresh_summary();
                                               }
                                               */
                                               @Override public void editingStopped(javax.swing.event.ChangeEvent e) {
                                                   super.editingStopped(e);    refresh_summary();
                                               }

                                               /* ini terlalu banyak tertrigger dalam satu eventnya.
                                               @Override public void valueChanged(ListSelectionEvent e) {
                                                    super.valueChanged(e);    refresh_summary();
                                               }
                                               */
                                           };
        else table = new JTable(db);

        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setSurrendersFocusOnKeystroke(true);
        TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(db);
        //sorter.setStringConverter( new TableStringConverter(
                  //public abstract String(db, int row, int column)
        //) );
        table.setRowSorter(sorter);
        table.putClientProperty("terminateEditOnFocusLost", true); //Paling tidak utk memaksa update terjadi saat filtering table:p >> Note that this solution will cause the table to stop editing when any component get focus. I believe this logic is limited to components on the current window, but must admit I havent tested it. This solution will also not work when you click on the window buttons (ie, minimize or close).

        Boolean sup_akses = retail.hak_akses.indexOf("'Supplier di Fitur Barang'") >= 0 ;
        Boolean disc_qty  = retail.convert_null(retail.setting.get("Aktifkan Diskon Quantity")).toLowerCase().equals("ya");
        Boolean barcode   = retail.convert_null(retail.setting.get("Prefer Barcode")).toLowerCase().equals("ya");
        db.column_model   = table.getColumnModel();
        JCdb Cagent = new JCdb("SELECT id, name FROM supplier ORDER BY IF(id=1,-111,name)");
        db.col_editor = new JComponent[] {    null,  null ,     null,          null, null,  Cagent          ,    null   ,     null   ,    null   ,     null   ,     null       ,      null      ,     null       ,      null      ,     null       ,      null      ,     null       ,      null      , null ,  null, null,    null    };
        db.col_width  = new int[]        {      0 ,    0  , (barcode?105:70) ,  170,  40 , (sup_akses?150:0),     70    ,      75    ,     70    ,      75    , (disc_qty?65:0), (disc_qty?90:0), (disc_qty?65:0), (disc_qty?90:0), (disc_qty?65:0), (disc_qty?90:0), (disc_qty?65:0), (disc_qty?90:0),  50  ,   50 ,  50 ,    300     };
        String sql =                 "SELECT   id , gambar,     code,          name, stok,  supplier_id     , harga_beli, diskon_beli, harga_jual, diskon_jual,  disc_qty1     ,  disc_amount1  ,  disc_qty2     ,  disc_amount2  ,  disc_qty3     ,  disc_amount3  ,  disc_qty4     ,  disc_amount4  , berat, omset, size, deskripsi FROM barang ORDER BY code";
        db.exec( sql, null, false, true );
        if( !db.err_msg.equals("") ) { error("Pembacaan Data Barang Gagal");   return; }
        sorter.setSortable(0, false);  sorter.setSortable(1, false);  sorter.setSortable(21, false);
        //mboh >> sorter.setComparator(2, new Comparator<String>() { @Override public int compare(String name1, String name2) {
	//	return name1.compareTo(name2);
	//}});
        //set height
        table.setRowHeight(row_height);
        JTableHeader header = new JTableHeader( db.column_model ) { @Override public Dimension getPreferredSize() {
                Dimension d = super.getPreferredSize();
                d.height = row_height;
                return d;
        }};
        table.setTableHeader(header);

        JScrollPane scrollpane = new JScrollPane(table);
        getContentPane().add(panel);        
        pack();

        getContentPane().add(panel);        
        panel.add(scrollpane);
        pack();
        setBounds(GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds()); // setAlwaysOnTop(true);   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); //setSize(800,800); //setExtendedState( getExtendedState()|JFrame.MAXIMIZED_BOTH );

        Bganti_gambar = new JButton("file gambar", retail.icon_image);
        Bganti_gambar.setBounds( parent.getWidth()-2*51 - (retail.gambar_size+6 -50-0), 55, retail.gambar_size+6 -50-0, 33 + 2 );    //Bganti_gambar.setBounds( scrollpane.getX() + scrollpane.getWidth() + 13, scrollpane.getY(), retail.gambar_size+6 -50-0, 33); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default

        scrollpane.setBounds( 50, Bganti_gambar.getY(), Bganti_gambar.getX() - 50 - 13, parent.getHeight()-2*55 -60);    //scrollpane.setBounds(50, 55, 750, 538);
        scrollpane.setBorder( BorderFactory.createRaisedBevelBorder() );
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(16, 16, 60, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "F2 - Edit Barang" ) ) );

        final JBkeluar Bkeluar = new JBkeluar(this);    panel.add(Bkeluar);

        Lgambar = new JLabel( "[ Gambar ]", JLabel.CENTER );    Lgambar.setForeground(Color.GRAY);
        JPopupMenu popup_gambar = new JPopupMenu();
        menu_hapus_gambar = new JMenuItem("hapus gambar ...", retail.icon_delete_image);
        menu_hapus_gambar.setMnemonic('H');
        menu_hapus_gambar.setEnabled(false);
        popup_gambar.add(menu_hapus_gambar);
        Lgambar.setComponentPopupMenu(popup_gambar);

        Bganti_gambar.setAlignmentX( Bkeluar.getAlignmentX() );
        Bganti_gambar.setIconTextGap( Bkeluar.getIconTextGap() );
        Bganti_gambar.setMnemonic('G');  Bganti_gambar.addFocusListener(retail.onHover);
        Bganti_gambar.setEnabled(false);
        panel.add(Bganti_gambar);

        Bambil_gambar = new JButton("", retail.icon_camera );
        Bambil_gambar.setAlignmentX ( Bkeluar.getAlignmentX() );
        Bambil_gambar.setIconTextGap( Bkeluar.getIconTextGap() );
        Bambil_gambar.setBounds( Bganti_gambar.getX()+Bganti_gambar.getWidth() + 0, Bganti_gambar.getY(), 50, Bganti_gambar.getHeight()); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        Bambil_gambar.setMnemonic('T');  Bambil_gambar.addFocusListener(retail.onHover);
        Bambil_gambar.setEnabled(false);
        Bambil_gambar.setToolTipText("F4 - Ambil Foto");
        panel.add(Bambil_gambar);

        Bhapus_gambar = new JButton("hapus gambar", retail.icon_delete_image);
        Bhapus_gambar.setAlignmentX( Bkeluar.getAlignmentX() );
        Bhapus_gambar.setIconTextGap( Bkeluar.getIconTextGap() );
        Bhapus_gambar.setMnemonic('U');  Bhapus_gambar.addFocusListener(retail.onHover);
        Bhapus_gambar.setEnabled(false);
        panel.add(Bhapus_gambar);
        ActionListener act_hapus_gambar = new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
            if( Lgambar.getText()!="") return;
            reset_gambar();
            //edit field gambar with "" then delete file gambar
            int row = table.convertRowIndexToModel( table.getSelectedRow() );
            String gambar_filename = table.getModel().getValueAt(row, 1).toString();
            table.getModel().setValueAt( "", row, 1 );
            ((AbstractTableModel)table.getModel()).fireTableCellUpdated(row, 1);  //fireTableDataChanged();
            new File( db.cfg.get("direktori_gambar") + gambar_filename ).delete();
        }};
        Bhapus_gambar.addActionListener(act_hapus_gambar);
        menu_hapus_gambar.addActionListener(act_hapus_gambar);

        ActionListener act_load_gambar = new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
            BufferedImage BIgambar = null;
            if( (JButton)e.getSource()==Bganti_gambar ) BIgambar = retail.load(Lgambar,"");
            else if( !Lgambar.getText().isEmpty() )     BIgambar = retail.load_scan(Lgambar);
            else if( 0==JOptionPane.showOptionDialog( Fedit_barang.this, "\nAmbil foto untuk mengganti gambar?\n\n\n\n", "Konfirmasi", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions2, null) )    //konfirmasi ini penting di Fedit krn tidak bisa diundo klo dia ga sengaja pencet F4:p
                                                        BIgambar = retail.load_scan(Lgambar);
            table.requestFocus();    //container.transferFocusBackward();
            if( BIgambar==null ) return;

            //simpan file gambar
            String ext = ( (JButton)e.getSource()==Bganti_gambar ) ? retail.ext( retail.file_dialog.getSelectedFile().getName() ) : ".jpg";
            int row = table.convertRowIndexToModel( table.getSelectedRow() );
            String code = table.getModel().getValueAt(row, 0).toString().trim();  //tambah id di belakang agar ga nyikat yg lain klo field code diedit user:p
            if( code.equals("0") ) code = table.getRowCount() + "-" + String.format( "%1$td_%<tm_%<ty_%<tH_%<tM_%<tS", new java.util.Date() ) ;
            code = table.getModel().getValueAt(row, 2).toString().replaceAll("[^a-zA-Z0-9\\.\\-]", "-").trim() + " - " + code;
            code = code.trim();    //krn bisa jadi user belum ngisi code sehingga filename diawali spasi sementara di db dah ketrim pas nyimpan:)
            table.getModel().setValueAt( code+ext, row, 1 );   //edit field gambar with code
            if( !db.err_msg.equals("") ) { reset_gambar();    return; }
            ((AbstractTableModel)table.getModel()).fireTableCellUpdated( row, 1 );

            //retail.copy_file( gambar_path, db.cfg.get("direktori_gambar") + code );    //then save file!
            String mime = "png";
            if( !ext.equals("") ) mime = ext.substring(1,ext.length());  //without dot // biar ajalah, lah png tu 10X lebih besar je ukuran filenya:) >> biar ga banyak data sampah saat gambar diedit dgn ext yg beda2
            try {
                ImageIO.write( BIgambar, mime, new File( db.cfg.get("direktori_gambar")+code+ext ) );    //then save file!
                //ga iso throw new RuntimeException("Penyimpanan file gambar gagal!");
            } catch( Exception ex ) {
                JOptionPane.showMessageDialog( Fedit_barang.this, "\nPenyimpanan file gambar \"" +db.cfg.get("direktori_gambar")+code+ext+ "\" gagal!\nPesan Kesalahan: " +ex+ "\n\n\n\n" , "Kesalahan", JOptionPane.ERROR_MESSAGE );
            }
            BIgambar.flush();    BIgambar = null;
        }};
        Bganti_gambar.addActionListener(act_load_gambar);
        Bambil_gambar.addActionListener(act_load_gambar);

        Lgambar.setBounds( Bganti_gambar.getX()+3, Bganti_gambar.getY()+Bganti_gambar.getHeight()+3, retail.gambar_size, retail.gambar_size ); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        Lgambar.setBorder( BorderFactory.createLoweredBevelBorder() );
        panel.add(Lgambar);
        Lgambar.addMouseListener( new MouseAdapter() { public void mouseClicked(MouseEvent e) {  //A mouseClicked event is only fired when a mousePressed and mouseReleased event is generated at the same pixel location
            if( e.getClickCount() >= 2 ) Bganti_gambar.doClick();
        }});

        Bhapus_gambar.setBounds( Bganti_gambar.getX(), Lgambar.getY()+Lgambar.getHeight()+3, Lgambar.getWidth() +6, Bganti_gambar.getHeight() );

        if( printer_label_rak ) {
            Bprint_label_rak = new JBprint(this, (byte)4);
            Bprint_label_rak.setBounds( Bhapus_gambar.getX(), Bhapus_gambar.getY()+50+5, Bhapus_gambar.getWidth(), Bhapus_gambar.getHeight() );    panel.add(Bprint_label_rak);
            Bprint_label_rak.setEnabled(false);
        }
        if( printer_barcode ) {
            Bprint_barcode = new JBprint(this, (byte)3);
            Bprint_barcode.setBounds( Bhapus_gambar.getX(), Bhapus_gambar.getY()+50+5+5+35, Bhapus_gambar.getWidth(), Bhapus_gambar.getHeight() );    panel.add(Bprint_barcode);
            Bprint_barcode.setEnabled(false);

            String[] cp = new String[1000];              //harus String[] >> int[] cp = new int[1000];
            for( int i=0; i<1000; i++ ) cp[i]=""+(i+1);    //for( int i=0; i<1000; i++ ) cp[i]=i+1;
            Ccopies = new JComboBox(cp);
            JComponent c = (JComponent)Ccopies.getRenderer();  
            c.setBorder( BorderFactory.createEmptyBorder( 4, 10, 4, 4 ) );  
            Ccopies.setRenderer( (ListCellRenderer)c );
            Ccopies.setSelectedIndex(2);
            Ccopies.addItemListener( new ItemListener() { public void itemStateChanged(ItemEvent e) {
                if( e.getStateChange()!=ItemEvent.SELECTED ) return;
                printer_barcode_set_copies();
            }});
            Ccopies.setBounds( Bprint_barcode.getX() + Bprint_barcode.getWidth() - 60, Bprint_barcode.getY()+Bprint_barcode.getHeight()+1, 60, Bprint_barcode.getHeight() );    panel.add(Ccopies);
            Ccopies.setEnabled(false);
            Lrangkap = new JLabel("Rangkap", JLabel.RIGHT);    Lrangkap.setLabelFor( Ccopies );    Lrangkap.setDisplayedMnemonic( 'N' );
            Lrangkap.setBounds( Ccopies.getX()-80-5, Ccopies.getY(), 80, Ccopies.getHeight() );  panel.add(Lrangkap);
            Lrangkap.setEnabled(false);
        }

        Bprint = new JBprint_auto(table);
        Bprint.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-20, Bkeluar.getY(), Bkeluar.getWidth(), Bkeluar.getHeight() );    //Bprint.setBounds( scrollpane.getX() + scrollpane.getWidth() + 20, scrollpane.getY() + scrollpane.getHeight() - Bkeluar.getHeight(), Bkeluar.getWidth(), Bkeluar.getHeight() );
        panel.add(Bprint);

        Bexport_xls = new JBexport_xls(this);    //ini harus sesudah init table dan Bsimpan (jika ada) krn constructor JBexport_xls ngebaca component2 tsb.
        Bexport_xls.setBounds( Bprint.getX()-Bprint.getWidth()-5, Bprint.getY(), Bprint.getWidth(), Bprint.getHeight() );
        panel.add(Bexport_xls);

        final JPopupMenu popup = new JPopupMenu();
        panel.add(popup);

        //JMenuItem menu_tambah = null;
        if( retail.hak_akses.indexOf("'" +modul.replace("Edit Data","Tambah")+ "'") >= 0 ) {
            menu_tambah = new JMenuItem("F11 - Tambah Baris Baru", retail.icon_insert);
            menu_tambah.setMnemonic(KeyEvent.VK_T);
            popup.add(menu_tambah);
            menu_tambah.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                    retail.add_row(table);
            }});
        }

        final JMenuItem menu_hapus = new JMenuItem("F12 - hapus baris ini", retail.icon_delete);
        menu_hapus.setMnemonic(KeyEvent.VK_H);
        menu_hapus.setEnabled(false);
        popup.add(menu_hapus);

        Bhapus = new JButton("F12 - hapus baris", retail.icon_delete);
        Bhapus.setAlignmentX( Bkeluar.getAlignmentX() );
        Bhapus.setIconTextGap( Bkeluar.getIconTextGap() );
        Bhapus.setBounds( Bexport_xls.getX()-Bprint.getWidth()-15-30, Bprint.getY(), Bprint.getWidth()+30, Bprint.getHeight() );//java default
        Bhapus.setMnemonic('H');  Bhapus.addFocusListener(retail.onHover);
        Bhapus.setEnabled(false);
        panel.add(Bhapus);
        ActionListener act_hapus = new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                int row = table.getSelectedRow();  //kucoba meringankan >> int row = table.convertRowIndexToModel( table.getSelectedRow() );
                if( row<0 ) return;
                table.requestFocus();
                if( 0 != JOptionPane.showOptionDialog( Fedit_barang.this, "\nData baris ke-" + (row+1) + " ingin dihapus?\n\n\n\n", "Konfirmasi", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions2, null) )   return;
                if( table.isEditing() ) table.getCellEditor().cancelCellEditing();    //jika tidak di sini, post editing terjadi setelah didelete ... lah?! aneh :)
                row = table.convertRowIndexToModel(row);
                if( Lgambar.getText()=="") {  //delete file
                    String gambar_filename = table.getModel().getValueAt(row, 1).toString();
                    //table.getModel().setValueAt( "", row, 1 );   ((AbstractTableModel)table.getModel()).fireTableCellUpdated(row, 1);  //fireTableDataChanged();
                    new File( db.cfg.get("direktori_gambar") + gambar_filename ).delete();
                }
                reset_gambar();
                db.removeRow(row);

                if( row<table.getRowCount() ) {
                    last_selected_row++;    //ngumpanin ListSelectionListener() ... agar tetap load_gambar
                    table.setRowSelectionInterval(row, row);
                }
                else if( table.getRowCount()>0 ) table.setRowSelectionInterval(row-1, row-1);   //ini harus sesudah diremove:p  else if( table.getRowCount()>0 ) table.setRowSelectionInterval(row+1, row+1);
                else {
                   Bhapus.setEnabled(false);    menu_hapus.setEnabled(false);
                }
                if( summary )
                    if( table.getRowCount()>0 ) {
                        table.editCellAt(0,4);    //ga jalan >> db.fireTableCellUpdated(0, 3);    //supaya summary refresh :p >>> //table.sorterChanged( new javax.swing.event.RowSorterEvent( rowSorter, javax.swing.event.RowSorterEvent.Type.SORTED, null) );    //supaya klo ada summary table dan Tcari sedang kosong, bisa terupdate juga:p
                        if( table.isEditing() ) table.getCellEditor().stopCellEditing();
                    } else if( !Titem.getText().trim().equals("0") ) {
                            Taset.setText  ("0");
                            Tmodal.setText ("0");
                            Tstok.setText  ("0");
                            Titem.setText  ("0");
                    }
        }};
        Bhapus.addActionListener(act_hapus);
        menu_hapus.addActionListener(act_hapus);

        retail.Brefresh.setBounds( Bhapus.getX()-Bexport_xls.getWidth()-15, Bexport_xls.getY(), Bexport_xls.getWidth(), Bexport_xls.getHeight() );
        panel.add(retail.Brefresh);

        JLabel Lcari = new JLabel("F1 - Cari", retail.icon_search, JLabel.LEFT);    Lcari.setDisplayedMnemonic('C');    Lcari.setFont( new Font( "Dialog", Font.BOLD, 12 ));    //"Cari   ( F1 )"
        Lcari.setBounds( 23, retail.Brefresh.getY(), 53+36, 35);  Lcari.setIconTextGap( Bkeluar.getIconTextGap()-2 );  panel.add(Lcari);
        final JTextField Tcari = new JTextField();    Tcari.setMargin( new Insets( 0, 7, 0, 0 ) );
        Tcari.setBounds( Lcari.getX()+Lcari.getWidth(), Lcari.getY(), retail.Brefresh.getX()-Lcari.getX()-Lcari.getWidth()-10, Lcari.getHeight() );  panel.add(Tcari);
        Tcari.requestFocus();
        Lcari.setLabelFor(Tcari);
        retail.add_search_on_change( Tcari, sorter, menu_tambah);
        if( !barcode_init.isEmpty() ) {
            Tcari.setText(barcode_init);
                table.requestFocus();
//ga ngefek            SwingUtilities.invokeLater(new Runnable(){ @Override public void run() {    //biar langsung kelihatan selected oleh user
                //if( table.getSelectedRow()<0 ) 
//table.setRowSelectionInterval(0,0);
//            }});
        }

        //let the default, for the barcode printing is ListSelectionModel.MULTIPLE_INTERVAL_SELECTION  << table.setSelectionMode(0);  //SINGLE_SELECTION

        table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //try{
                if( e.getValueIsAdjusting() ) return;    //ini sudah menggantikan "just filtered" di bawah
                printer_barcode_set_copies();
                int row = table.getSelectedRow();    //Lcari.setText( Lcari.getText() + " " + row);
                /*
                AbstractDocument doc = (AbstractDocument) Tcari.getDocument();
                if( last_selected_row == -2 ) last_selected_row = row;    //ini hanya mengcopy selected row sebelum difilter. Action ini dilakukan pada event ke 2 dari 4 event tiap sekali filter :(
                if( (Boolean)doc.getProperty("just filtered") ) {
                    last_selected_row = -2;    //utk mendetect event ke 2 dari 4 event tiap sekali filter, ribet kan? :p
                    doc.putProperty("just filtered", false );
                }
                */
                if( row<0 ) {    //if( row<0 || last_selected_row==row ) return;    //supaya ga diulang2 mulu
                    Bhapus.setEnabled(false);    menu_hapus.setEnabled(false);
                    reset_gambar();
                    Bganti_gambar.setEnabled(false);    Bambil_gambar.setEnabled(false);
                    return;
                }
                Bhapus.setEnabled(true);    menu_hapus.setEnabled(true);    if( printer_barcode ) {    Bprint_barcode.setEnabled(true);    Bprint_label_rak.setEnabled(true);    Ccopies.setEnabled(true);    Lrangkap.setEnabled(true);    }    //jgn taruh di bawah krn ada kasus di mana user selectrow lalu filtering sehingga table.getSelectedRow()==-1 trus unfiltering ... lah, tombol ini ga terenable:)
                row = table.convertRowIndexToModel( row );  //ini berat sehingga lambat saat filter!!
                if( last_selected_row==row && Bganti_gambar.isEnabled() ) return;    //supaya ga diulang2 mulu

                String gambar_filename = table.getModel().getValueAt( row, 1).toString().trim();
                if( !gambar_filename.equals("") ) {
                    retail.load( Lgambar, gambar_filename );  //if( !retail.load( Lgambar, gambar_filename ).equals("") )
                    if( Lgambar.getIcon()==null ) reset_gambar();    //berarti load imagenya gagal
                } else if( Lgambar.getText()==""  )
                    reset_gambar();  //Bhapus_gambar.doClick();

                //tetep aja membingungkan user:). so, sudah ditangani di load_gambar di atas >> String id_ = table.getModel().getValueAt(row, 0).toString().trim();    String code_ = table.getModel().getValueAt(row, 2).toString().trim();
                //Bganti_gambar.setEnabled( !id_.isEmpty() && !id_.equals("0") && !code_.isEmpty() );    Bambil_gambar.setEnabled( Bganti_gambar.isEnabled() );    //so, user silently told that he has to fill the code first:p
                Bganti_gambar.setEnabled(true);    Bambil_gambar.setEnabled(true);

                if( last_selected_row>=0 && last_selected_row<db.getRowCount() ) {    //please do when filtered. We already use row from convertRowIndexToModel  >> last_selected_row<table.getRowCount() && table.getRowCount()==db.getRowCount() ) {    //user batal nginsert row   //dont do when filtered
                    String left_val = db.getValueAt(last_selected_row, 0).toString();    //table.convertRowIndexToModel(last_selected_row);
                    if( left_val.equals("0") || left_val.equals("") ) db.removeRow( last_selected_row );  //user batal nginsert row   //retail.db.rows.removeElementAt(last_row);
                }

                last_selected_row = row;    //Lcari.setText( Lcari.getText() + " " + row);
                //table.requestFocus();    //container.transferFocusBackward();

                //} catch (Exception ex) {    JOptionPane.showMessageDialog( null, "from listselection\n. Pesan Kesalahan: " + ex, "Gagal baca Variable", JOptionPane.ERROR_MESSAGE); }
            }
        });

        table.addMouseListener( new MouseListener() {
            public void mousePressed(MouseEvent e) {
                if( !( e.getComponent() instanceof JTable && (e.getModifiers() & InputEvent.BUTTON3_MASK ) == InputEvent.BUTTON3_MASK ) ) return;
                JTable table = (JTable)e.getComponent();
                int row = table.rowAtPoint(e.getPoint());
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //doesn't work >> table.transferFocus();  //post update jika icon close diklik atau ALT-F4 :)  //ga mo cerewet ah:)) >> if( !db.err_msg.equals("") ) { error("Update Data Gagal");   return; }
                table.setRowSelectionInterval(row, row);
                popup.show(table, e.getX(), e.getY());   //table.setComponentPopupMenu(popup);  //ga listening klo di klik kanan ulang di tempat lain :p
            }
            public void mouseClicked(MouseEvent e) {}    public void mouseEntered(MouseEvent e) {}    public void mouseExited(MouseEvent e) {}    public void mouseReleased(MouseEvent e) {}
        });

        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                close();
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  
            @Override public void windowClosing(WindowEvent e) {
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update jika icon close diklik atau ALT-F4 :)  //ga mo cerewet ah:)) >> if( !db.err_msg.equals("") ) { error("Update Data Gagal");   return; }
                Bkeluar.doClick();
            }
        });

        if( summary ) {
            JLabel Laset = new JLabel("Aset    Rp.");  Laset.setFont(new Font( Font.DIALOG, Font.PLAIN, 12 ));
            Laset.setBounds( Bhapus_gambar.getX(), scrollpane.getY()+scrollpane.getHeight()-Bhapus_gambar.getHeight(), 62-5, Bhapus_gambar.getHeight() );  panel.add(Laset);
            Taset = new JTextField("");  Taset.setEditable(false);  Taset.setBackground(retail.disabled_color);  Taset.setFont( new Font( "Kartika", Font.BOLD, 20 ) );  Taset.setHorizontalAlignment(JTextField.RIGHT);  //Taset.setMargin( new Insets( 0, 7, 0, 0 ) );
            Taset.setBounds( Laset.getX()+Laset.getWidth(), Laset.getY(), Bhapus_gambar.getWidth()-Laset.getWidth(), Laset.getHeight() );  panel.add(Taset);

            Tmodal = new JTextField("");  Tmodal.setEditable(false);  Tmodal.setBackground(Taset.getBackground());  Tmodal.setFont(Taset.getFont());  Tmodal.setHorizontalAlignment(JTextField.RIGHT);  Tmodal.setMargin( Taset.getMargin() );
            Tmodal.setBounds( Taset.getX(), Laset.getY()-Taset.getHeight()-2, Taset.getWidth(), Taset.getHeight() );  panel.add(Tmodal);
            JLabel Lmodal = new JLabel("Modal Rp.");  Lmodal.setFont(Laset.getFont());
            Lmodal.setBounds( Laset.getX(), Tmodal.getY(), Laset.getWidth(), Taset.getHeight() );  panel.add(Lmodal);

            Tstok = new JTextField("");  Tstok.setEditable(false);  Tstok.setBackground(Taset.getBackground());  Tstok.setFont(Taset.getFont());  Tstok.setHorizontalAlignment(JTextField.RIGHT);  Tstok.setMargin( Taset.getMargin() );
            Tstok.setBounds( Tmodal.getX(), Lmodal.getY()-Tmodal.getHeight()-2, Tmodal.getWidth(), Tmodal.getHeight() );  panel.add(Tstok);
            JLabel Lstok = new JLabel("Stok");  Lstok.setFont(Laset.getFont());
            Lstok.setBounds( Laset.getX(), Tstok.getY(), Laset.getWidth(), Taset.getHeight() );  panel.add(Lstok);

            Titem = new JTextField("");  Titem.setEditable(false);  Titem.setBackground(Taset.getBackground());  Titem.setFont(Taset.getFont());  Titem.setHorizontalAlignment(JTextField.RIGHT);  Titem.setMargin( Taset.getMargin() );
            Titem.setBounds( Tstok.getX(), Lstok.getY()-Tstok.getHeight()-2, Tstok.getWidth(), Tstok.getHeight() );  panel.add(Titem);
            JLabel Litem = new JLabel("Item");  Litem.setFont(Laset.getFont());
            Litem.setBounds( Laset.getX(), Titem.getY(), Laset.getWidth(), Taset.getHeight() );  panel.add(Litem);

            refresh_summary();

            /*
            summary_actionListener = new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                refresh_summary();
            }};
            retail.Brefresh.addActionListener(summary_actionListener);
            Tcari.addActionListener(summary_actionListener);

            sorter.addRowSorterListener(new RowSorterListener() { @Override public void sorterChanged(RowSorterEvent e) {
                refresh_summary();
            }});
            */
        }
        retail.removeTitleButtons(this, onClose);
        setVisible(true);
    }

    void refresh_summary() {
        if(!summary) return;
        long aset=0;  long modal=0;  int stok=0;  int item=-1;
        for( int i=0; i<table.getRowCount(); i++ ) {
            int stok_i  = Integer.valueOf( table.getValueAt( i, table.convertColumnIndexToView(4)).toString() );    //db.getIntAt(i, 17);
            if( stok_i<0 ) stok_i=0;
            stok  += stok_i;
            aset  += stok_i*Long.valueOf( table.getValueAt( i, table.convertColumnIndexToView( 8) ).toString() );    //db.getIntAt(i, 7);
            modal += stok_i*Long.valueOf( table.getValueAt( i, table.convertColumnIndexToView( 6) ).toString() );    //db.getIntAt(i, 5);
            item   = i;
            /* ini ga mendeteksi klo col diswitch oleh user:p
            aset  += Integer.valueOf( table.getValueAt( i,  7 -2-(db.col_width[4]==0?0:1) ).toString() );    //db.getIntAt(i, 7);
            modal += Integer.valueOf( table.getValueAt( i,  5 -2-(db.col_width[4]==0?0:1) ).toString() );    //db.getIntAt(i, 5);
            stok  += Integer.valueOf( table.getValueAt( i, 17 -2-(db.col_width[4]==0?0:1) -(db.col_width[9]==0?0:8) ).toString() );    //db.getIntAt(i, 17);
            */
        }
        Taset.setText  ( String.format("%,d", aset  ));
        Tmodal.setText ( String.format("%,d", modal ));
        Tstok.setText  ( String.valueOf( stok   ) );
        Titem.setText  ( String.valueOf( item+1 ) );
    }

    void reset_gambar() {
        if( Lgambar.getText()!="") return;
        Lgambar.setIcon(null);
        Lgambar.setText( "[ Gambar ]" );
        Bhapus_gambar.setEnabled(false);    menu_hapus_gambar.setEnabled(false);
        //ga jadi >> Bganti_gambar.setText( "Masukkan Gambar" );  //hehe
    }
    void close() {
        try { db.rs.close(); } catch (Exception e) {}
        db.close(); table.setRowSorter(null);  //sorter=null;  //aneh aja ... tanpa ini, jika row diubah urutannya trus didelete, lalu ditutup-buka lagi, terjadi error saat fireTableRowsInserted(getRowCount()-1, getRowCount()-1);
        dispose();
        retail.reset_brg();
        //if( summary ) retail.Brefresh.removeActionListener(summary_actionListener);
    }
    void error(String title) {
        JOptionPane.showMessageDialog( this, db.err_msg, title, JOptionPane.ERROR_MESSAGE);
        close();
    }
    void printer_barcode_set_copies() {
        if( !printer_barcode ) return;
        String text = Bprint_barcode.getText();
        int pos = text.indexOf("(");
        if( pos>0 ) text = text.substring(0,pos).trim();
        int row_count = table.getSelectedRowCount();
        String copies = String.valueOf( row_count * (Ccopies.getSelectedIndex()+1) );
        copies = " (" + copies + ")";
        Bprint_barcode.setText( text + copies );    Bprint_barcode.setToolTipText( text + copies + ". Tahan tombol Ctrl atau Shift lalu klik pada tabel untuk memilih data! ");
        text = Bprint_label_rak.getText();
        pos = text.indexOf("(");
        if( pos>0 ) text = text.substring(0,pos).trim();
        copies = " (" + row_count + ")";
        Bprint_label_rak.setText( text + copies );    Bprint_label_rak.setToolTipText( text + copies + ". Tahan tombol Ctrl atau Shift lalu klik pada tabel untuk memilih data! ");
    }

    //to print
    public Object[][] title_header() {
            Object[][] title_header = {
                };
            return title_header;
    }
    public Object[][] table_summary() {
            Object[][] table_summary = {
                };
            return table_summary;
    }
}