/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.table.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

import java.text.SimpleDateFormat;
import java.util.Date;

import java.sql.Types;
//import org.jdesktop.swingx.JXDatePicker;

//ya harus tekan Esc :p >> klo user klik combo tapi tetap pilih empty ... gmn:p
public class Fretur_pembelian extends JDialog {
//    JCdb Ccode_brg;    JCdb Cname_brg;    int[] harga_brg;    int[] diskon_brg;    String[] gambar_brg;

    private db_connection db = new db_connection() {    //indahnya inherit :)        //private static db_connection db = retail.db;
        public void setValueAt(Object val, int row_idx, int col_idx) {
            if( to_str( col_idx, getValueAt(row_idx, col_idx).toString().trim() ).equals( to_str(col_idx, val.toString().trim()) ) ) return;
            if( Integer.valueOf(val.toString()) > getIntAt(row_idx, 3) ) {
                JOptionPane.showMessageDialog( table,  "\nBanyak barang yang hendak diretur tidak boleh lebih besar dari jumlah semula!\n\n\n\n\n", "Kesalahan", JOptionPane.ERROR_MESSAGE );
                table.requestFocus();
                return;
            }
            super.setValueAt(val, row_idx, col_idx);
            if( col_idx==4 )  { //set total_i = harga * (100 - diskon)     * banyak                   ) /100
                int total_i = retail.round( (long) getIntAt(row_idx, 2) * (100 - getIntAt(row_idx, 5)) * Integer.valueOf(val.toString()) , 100 );    //tetap pakai prosentase krn klo gak ya bingung:p    //int total_i = getIntAt(row_idx, 2) * Integer.valueOf(val.toString()) - getIntAt(row_idx, 5) ;
                if( total_i<0 ) {   //exceed int max: 2.147.483.647  .. sebetulnya ini blm bs detect klo dia pas 2.147.483.647 krn total_i akan samadengan 0 :D .. luweh
                    JOptionPane.showMessageDialog( table,  "Total harga terlalu besar.", "Kesalahan", JOptionPane.ERROR_MESSAGE );
                    total_i=0;
                }
                super.setValueAt( total_i, row_idx, 7 );       //super.setValueAt( Integer.valueOf( super.getValueAt(row_idx, 2).toString()) * (1- Integer.valueOf(super.getValueAt(row_idx, 4).toString().replace("%","")) /100)  * Integer.valueOf(super.getValueAt(row_idx, 3).toString()), row_idx, 5 );
                hitung_sub_total();
                if( total_i==0 || sub_total==0 ) table.requestFocus();
            }
        }
    };

    String no_faktur_before  = "";    String no_faktur  = "";    String no_faktur_hapus = "";
    String jam_faktur = "";
    //JXDatePicker Dtgl_faktur;
    JTextField Tname_agent;    JTextField Tcode_agent;    JTextField Tkontak_agent;
    JTextField Tno_faktur;     JTextField Ttgl_faktur;

    //must be public to let retail.click_button() ...
    public JBprint Bprint;
    public JButton Bbaru; 
    public JButton Bhapus_faktur;
    public JBexport_xls Bexport_xls;

    public JButton Bsimpan;    //must be public utk dipakai di class Bprint ...

    JLabel Lgambar;

    public JTable_db table;
    int last_selected_row = -13;    int sup_id = -13;    //int brg_id = retail.brg_id;    //-13;

    byte prosentase_ppn = retail.is_number( retail.convert_null(retail.setting.get("Prosentase PPN")) ) ? Byte.valueOf( retail.convert_null(retail.setting.get("Prosentase PPN")) ) : 0 ;
    int sub_total = 0;    int total = 0;  int total_round = 0;
    int ppn = 0;    int diskon = 0;
    int total_faktur = 0;    int sub_total_faktur = 0;
    JTextField Tdiskon_edit = new JTextField("0");    //perlu diintiate krn kena Integer.valueOf("")
    JTextField Tdiskon = new JTextField();
    JCheckBox CHppn = new JCheckBox("PPN", retail.db.cfg.get("ppn_aktif_secara_default").equals("ya") );
    JTextField Tppn = new JTextField();
    JTextField Tsub_total = new JTextField();
    JTextField Ttotal = new JTextField();
    JLabel Ltotal_blink = new JLabel();
    JTextField Ttotal_faktur = new JTextField();
    Timer timer_title;    Timer timer_total;

    public Fretur_pembelian(final JFrame parent) {
        super(parent, retail.app_name + " - Retur Pembelian" + "   ::   Petugas: " + retail.nama, true);
        timer_title = new Timer(500, new clock(this));    timer_title.start();
        //Ccode_brg  = retail.Ccode_brg;    Cname_brg  = retail.Cname_brg;    harga_brg  = retail.harga_brg;    diskon_brg = retail.diskon_brg;    gambar_brg = retail.gambar_brg;
        final String modul = "Retur Pembelian";
        final int row_height = 38;    //32
        //String err_msg = "";
        setIconImage(retail.icon_app);
//try{
        JPanel panel_wrap = new JPanel(null);
        getContentPane().add(panel_wrap);
        pack();

        setBounds(GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds()); // setAlwaysOnTop(true);   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); //setSize(800,800); //setExtendedState( getExtendedState()|JFrame.MAXIMIZED_BOTH );

        JPanel panel_agent = new JPanel(null);
        panel_agent.setBounds( parent.getWidth()-320-25, 5, 320, 110);
        panel_agent.setBorder( BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Supplier" ) );    //panel_total.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Supplier" ), new EmptyBorder(16, 16, 60, 16) ) );

        JLabel Lname_agent = new JLabel("Nama");          Lname_agent.setBounds( 19, 29, 36, 29);  Lname_agent.setForeground(Color.GRAY);  Lname_agent.setDisplayedMnemonic('A');  panel_agent.add(Lname_agent);

        //klo ingin bisa ngedit supplier/pelanggan, mending utilize Fpembelian aja:p
        Tname_agent = new JTextField();  Tname_agent.setEditable(false);  Tname_agent.setBackground(retail.disabled_color);  Tname_agent.setBounds( 2+Lname_agent.getX() + Lname_agent.getWidth(), Lname_agent.getY()+5, 230+20, Lname_agent.getHeight() );  Lname_agent.setLabelFor(Tname_agent);  panel_agent.add(Tname_agent);
        JLabel Lcode_agent = new JLabel("Kode");          Lcode_agent.setBounds( Lname_agent.getX(), Lname_agent.getY()+Lname_agent.getHeight()+7, Lname_agent.getWidth(), Lname_agent.getHeight() );  Lcode_agent.setForeground( Lname_agent.getForeground() );  Lcode_agent.setDisplayedMnemonic('D');  panel_agent.add(Lcode_agent);
        Tcode_agent = new JTextField();  Tcode_agent.setEditable(false);  Tcode_agent.setBackground(Tname_agent.getBackground());            Tcode_agent.setBounds( Tname_agent.getX(), Lcode_agent.getY()+5, 70+15, Tname_agent.getHeight() );  Lcode_agent.setLabelFor(Tcode_agent);  panel_agent.add(Tcode_agent);
        JLabel Lkontak_agent = new JLabel("Kontak");      Lkontak_agent.setBounds( Tcode_agent.getX()+Tcode_agent.getWidth()+10, Lcode_agent.getY(), 40, Lname_agent.getHeight() );  Lkontak_agent.setForeground( Lname_agent.getForeground() );  Lkontak_agent.setDisplayedMnemonic('O');  panel_agent.add(Lkontak_agent);
        Tkontak_agent = new JTextField();  Tkontak_agent.setEditable(false);  Tkontak_agent.setBackground(Tname_agent.getBackground());  Tkontak_agent.setBounds( 2+Lkontak_agent.getX()+Lkontak_agent.getWidth(), Lkontak_agent.getY()+5, Tname_agent.getWidth() - Tcode_agent.getWidth() - 10 - Lkontak_agent.getWidth() - 2, Tname_agent.getHeight() );  Lkontak_agent.setLabelFor(Tkontak_agent);  panel_agent.add(Tkontak_agent);
        panel_wrap.add(panel_agent);    //ga ngaruh >> di bawah aja agar table jadi focus yg pertama :p



        JPanel panel_total = new JPanel(null);
        panel_total.setBounds( 10, panel_agent.getY(), panel_agent.getX()-2*10, panel_agent.getHeight() );
        panel_total.setBorder( BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Total Retur" ) );    //panel_total.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Total" ), new EmptyBorder(16, 16, 60, 16) ) );
        retail.init_colors();
        Ltotal_blink.setBounds( 10, 27, panel_total.getWidth()-2*10, panel_total.getHeight()-27-10 );
        //Ltotal_blink.setBorder( BorderFactory.createLoweredBevelBorder() );
        Ltotal_blink.setFont( new Font("Kartika", Font.BOLD, 120) );    //new Font(Font.DIALOG, Font.BOLD, 48);    //"Serif", Font.PLAIN, 24    //new Font("Trebuchet MS", Font.PLAIN, 12 ))
        //Ltotal_blink.setForeground( retail.colors[0] );
        panel_total.add(Ltotal_blink);
        timer_total = new Timer( retail.DELAY, new blink(Ltotal_blink)); timer_total.setInitialDelay(0);  timer_total.setCoalesce(true);  timer_total.start();    //new Timer( retail.DELAY, new blink(Ltotal_blink)).start();
        panel_wrap.add(panel_total);    //ga ngaruh >> di bawah aja agar table jadi focus yg pertama :p




        final JPanel panel = new JPanel(null);
        panel.setBounds( panel_total.getX(), panel_total.getY()+panel_total.getHeight(), parent.getWidth()-2*panel_total.getX()-15, parent.getHeight()-panel_total.getHeight()-11*panel_total.getY() );

        final JBkeluar Bkeluar = new JBkeluar(this);
        Bkeluar.setBounds( panel.getWidth() - 20 - (retail.gambar_size+6 - 15), panel.getHeight()-Bkeluar.getHeight()-15, retail.gambar_size+6 - 15, Bkeluar.getHeight());  panel.add(Bkeluar);
        //Bkeluar.setBounds( scrollpane.getX() + scrollpane.getWidth() + 20 + 15, scrollpane.getY()+scrollpane.getHeight()-Bkeluar.getHeight(), retail.gambar_size+6 - 15, Bkeluar.getHeight());  panel.add(Bkeluar);

        Ttotal.setEditable(false);    Ttotal.setBackground(retail.disabled_color);    Ttotal.setFont( new Font( "Kartika", Font.BOLD, 20 ) );  Ttotal.setHorizontalAlignment(JTextField.RIGHT);  Ttotal.setMargin( new Insets( 0, 0, 0, 7 ) );
        Ttotal.setBounds( Bkeluar.getX()-25-100, Bkeluar.getY(), 100, 29 );  panel.add(Ttotal);
        JLabel Ltotal = new JLabel("Total Retur");  Ltotal.setFont( new Font( Font.DIALOG, Font.BOLD, 12 ) );
        Ltotal.setBounds( Ttotal.getX()-120, Ttotal.getY(), 120, Ttotal.getHeight() );  panel.add(Ltotal);
 
        Tppn.setEditable(false);  Tppn.setBackground(Ttotal.getBackground());  Tppn.setFont(Ttotal.getFont());  Tppn.setHorizontalAlignment(JTextField.RIGHT);  Tppn.setMargin( new Insets( 0, 0, 0, 7 ) );
        Tppn.setBounds( Ttotal.getX(), Ttotal.getY()-Ttotal.getHeight()-1, Ttotal.getWidth(), Ttotal.getHeight() );  panel.add(Tppn);
        CHppn.setFont(Ltotal.getFont());
        CHppn.setBounds( Ltotal.getX()-2, Tppn.getY(), Ltotal.getWidth(), Tppn.getHeight() );  CHppn.setMnemonic('N');  panel.add(CHppn);
        CHppn.setEnabled(false);  CHppn.setBackground(Ltotal.getBackground());  CHppn.setForeground(Ltotal.getForeground());

        Tdiskon.setEditable(false);  Tdiskon.setBackground(Ttotal.getBackground());  Tdiskon.setFont(Ttotal.getFont());  Tdiskon.setHorizontalAlignment(JTextField.RIGHT);  Tdiskon.setMargin( new Insets( 0, 0, 0, 7 ) );
        Tdiskon.setBounds( Tppn.getX(), Tppn.getY()-Tppn.getHeight()-1, Tppn.getWidth(), Tppn.getHeight() );  panel.add(Tdiskon);
        JLabel Lpersen = new JLabel("%");  Lpersen.setFont(Ltotal.getFont());
        Lpersen.setBounds( Tdiskon.getX()-30, Tdiskon.getY(), 30, Tdiskon.getHeight() );  panel.add(Lpersen);
        Tdiskon_edit.setEditable(false);  Tdiskon_edit.setBackground(Ttotal.getBackground());  Tdiskon_edit.setFont( new Font( "Book Antigua", Font.PLAIN, 12 ) );  Tdiskon_edit.setHorizontalAlignment(JTextField.RIGHT);  Tdiskon_edit.setMargin( new Insets( 0, 0, 0, 3 ) );
        Tdiskon_edit.setBounds( Lpersen.getX()-35, CHppn.getY()-CHppn.getHeight()-1, 35, CHppn.getHeight() );  panel.add(Tdiskon_edit);
        JLabel Ldiskon = new JLabel("Potongan");  Ldiskon.setFont(Ltotal.getFont());  Ldiskon.setDisplayedMnemonic('T');  Ldiskon.setLabelFor(Tdiskon_edit);
        Ldiskon.setBounds( Ltotal.getX(), Tdiskon.getY(), CHppn.getWidth()-Tdiskon_edit.getWidth()-Lpersen.getWidth(), Tdiskon.getHeight() );  panel.add(Ldiskon);
 
        //Tdiskon.setVisible(false);  Tdiskon_edit.setVisible(false);  Lpersen.setVisible(false);  Ldiskon.setVisible(false);  

        Tsub_total.setEditable(false);  Tsub_total.setBackground(Ttotal.getBackground());  Tsub_total.setFont(Ttotal.getFont());  Tsub_total.setHorizontalAlignment(JTextField.RIGHT);  Tsub_total.setMargin( new Insets( 0, 0, 0, 7 ) );
        Tsub_total.setBounds( Tdiskon.getX(), Tdiskon.getY()-Tdiskon.getHeight()-1, Tdiskon.getWidth(), Tdiskon.getHeight() );  panel.add(Tsub_total);
        JLabel Lsub_total = new JLabel("Sub Total Retur");  Lsub_total.setFont(Ltotal.getFont());
        Lsub_total.setBounds( Ltotal.getX(), Tsub_total.getY(), CHppn.getWidth(), Tsub_total.getHeight() );  panel.add(Lsub_total);

        final JButton Blihat = new JButton( "lihat faktur", retail.icon_lihat );    Blihat.setAlignmentX( Bkeluar.getAlignmentX() );    Blihat.setIconTextGap( Bkeluar.getIconTextGap()+3 );
        Blihat.setBounds( Lsub_total.getX() -95-125, Lsub_total.getY(), 125, Bkeluar.getHeight() );
        Blihat.setMnemonic('L');  Blihat.addFocusListener(retail.onHover);
        Blihat.setEnabled(false);
        panel.add(Blihat);

        Tno_faktur = new JTextField();  Tno_faktur.setFont(Tdiskon_edit.getFont());  Tno_faktur.setMargin( new Insets( 0, 7, 0, 0 ) );    //Tno_faktur.setHorizontalAlignment(JTextField.RIGHT);
        Tno_faktur.setBounds( Blihat.getX()-10-200, Lsub_total.getY(), 200, Lsub_total.getHeight() );  panel.add(Tno_faktur);
        //scrollpane.getX()

        final JLabel Lno_faktur = new JLabel("No. Faktur Beli");  Lno_faktur.setFont(Ltotal.getFont());  Lno_faktur.setDisplayedMnemonic('F');  Lno_faktur.setLabelFor(Tno_faktur);
        Lno_faktur.setBounds( Tno_faktur.getX()-90, Tno_faktur.getY(), 90, Tno_faktur.getHeight() );  panel.add(Lno_faktur);
        //jika digunakan sebagai form cari -> edit?! >> Tno_faktur.setText( String.format("%,d", no_faktur) ) ;

        Ttgl_faktur = new JTextField();  Ttgl_faktur.setFont(Tno_faktur.getFont());   Ttgl_faktur.setMargin( Tno_faktur.getMargin() );    //karakter "-0" jelek (lengket) dengan font Kartika    //penambahan spasi di depan malah bikin kemungkinan gagal kalo diketik manual " dd-MM-yyyy"
        Ttgl_faktur.setBounds( Tno_faktur.getX(), Tno_faktur.getY()+Tno_faktur.getHeight()+10, Tno_faktur.getWidth(), Tno_faktur.getHeight() );
        //Dtgl_faktur.setLinkDay(new Date(), "Hari ini: {0, date, EEEE, dd-MM-yyyy}");    //ini tanpa koma?:) >> full
        Ttgl_faktur.setEditable(false);  Ttgl_faktur.setBackground(Ttotal.getBackground());
        panel.add(Ttgl_faktur);

        final String no_faktur_date_format = retail.user_id + "_%1$td.%<tm.%<ty.%<tH.%<tM.%<tS";
        Tno_faktur.setText( String.format( no_faktur_date_format, new Date() ) ) ;    //sebelum listener aja agar Blihat tidak enable ... krn ini hanya sebagai guidance aja dan ga mungkin ada di db.
        AbstractDocument no_faktur_doc = (AbstractDocument) Tno_faktur.getDocument();    //no_faktur_doc.setDocumentFilter(new PatternFilter("\\d{0,2}"));
        no_faktur_doc.setDocumentFilter(new PatternFilter( ".{0,26}" ));    //4 karakter terakhir utk sequence klo duplikat
        no_faktur_doc.addDocumentListener( new DocumentListener() {
            public void changedUpdate(DocumentEvent e) {
                Blihat.setEnabled( !Tno_faktur.getText().trim().isEmpty() );
            }
            public void removeUpdate(DocumentEvent e) { changedUpdate(e); }
            public void insertUpdate(DocumentEvent e) { changedUpdate(e); }
        });
        Tno_faktur.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            Blihat.doClick();
	}});

        JLabel Ltgl_faktur = new JLabel("Tgl. Faktur");  Ltgl_faktur.setFont(Ltotal.getFont());  Ltgl_faktur.setDisplayedMnemonic('G');  Ltgl_faktur.setLabelFor(Ttgl_faktur);
        Ltgl_faktur.setBounds( Lno_faktur.getX(), Ttgl_faktur.getY(), Lno_faktur.getWidth(), Ttgl_faktur.getHeight() );  panel.add(Ltgl_faktur);


        Ttotal_faktur.setFont(Tno_faktur.getFont());   Ttotal_faktur.setMargin( Tno_faktur.getMargin() );    //karakter "-0" jelek (lengket) dengan font Kartika    //penambahan spasi di depan malah bikin kemungkinan gagal kalo diketik manual " dd-MM-yyyy"
        Ttotal_faktur.setBounds( Tno_faktur.getX(), Ttgl_faktur.getY()+Ttgl_faktur.getHeight()+10, Tno_faktur.getWidth(), Tno_faktur.getHeight() );
        Ttotal_faktur.setEditable(false);  Ttotal_faktur.setBackground(Ttotal.getBackground());
        panel.add(Ttotal_faktur);

        JLabel Ltotal_faktur = new JLabel("Total Faktur");  Ltotal_faktur.setFont(Ltotal.getFont());  Ltotal_faktur.setDisplayedMnemonic('U');  Ltotal_faktur.setLabelFor(Ttotal_faktur);
        Ltotal_faktur.setBounds( Lno_faktur.getX(), Ttotal_faktur.getY(), Lno_faktur.getWidth(), Ttotal_faktur.getHeight() );  panel.add(Ltotal_faktur);


        table = new JTable_db(db);
        //table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        //table.setSurrendersFocusOnKeystroke(true);
        //TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(db);
        //sorter.setSortsOnUpdates(true);    //If true, specifies that a sort should happen when the underlying model is updated (rowsUpdated is invoked). For example, if this is true and the user edits an entry the location of that item in the view may change. The default is false.
        table.setRowSorter( new TableRowSorter<TableModel>(db) );
        //no we don't need this here, because we had Bsimpan. But this thing had been taking my 2 days:p just lead my wonder si. Anyway, still we have to be carefull of it according to this bug: http://stackoverflow.com/questions/1652942/can-a-jtable-save-data-whenever-a-cell-loses-focus
        //table.putClientProperty("terminateEditOnFocusLost", true); //Paling tidak utk memaksa update terjadi saat filtering table:p >> Note that this solution will cause the table to stop editing when any component get focus. I believe this logic is limited to components on the current window, but must admit I havent tested it. This solution will also not work when you click on the window buttons (ie, minimize or close).
        table.setFillsViewportHeight(true);

        db.column_model = table.getColumnModel();

        //retail.get_brg(table);    if( !db.err_msg.equals("") ) { close();   return; }        //((JComponent)retail.Ccode_brg).putClientProperty(JLabel.LABELED_BY_PROPERTY, table);    //JComponent.NEXT_FOCUS  //retail.tbl_brg = table;
        //Ccode_brg  = retail.Ccode_brg;    Cname_brg  = retail.Cname_brg;    harga_brg  = retail.harga_brg;    diskon_brg = retail.diskon_brg;    gambar_brg = retail.gambar_brg;

        db.col_width     = new int[]        {          -100, -(Ttotal.getX()+Ttotal.getWidth()-15 -5 -100-100-75-70-70-130),          -100,            -70,              75,           -70,             0,          -130,             0 };   // (-) means not editable:)
        db.col_editor    = new JComponent[] {          null,                                                           null,          null,           null,            null,          null,          null,          null,          null };
        db.col_label     = new String[]     {        "kode",                                                         "item",       "harga",       "banyak", "banyak__retur",      "diskon",      "gambar", "total_retur",   "barang_id" };    //there is noway to have multiline header :p >> but this worth to try: The JTableHeader uses a TableCellRenderer just like any other row, so replace the existing header renderer with a version of your word-wrapping one.     //"<html><center>Cod Type<br>Group"  //error dari jdbcnya:( >> You cannot specify target table 'barang' for update in FROM clause >> barang_id = "(SELECT id FROM barang WHERE code='" +barang_id+ "')";    //don't contact the db, just create my own RowSetMetaData:)
        db.col_type      = new int[]        { Types.VARCHAR,                                                  Types.VARCHAR, Types.INTEGER, Types.SMALLINT, Types.SMALLINT,  Types.TINYINT, Types.VARCHAR, Types.INTEGER, Types.TINYINT };
        db.col_precision = new int[]        {             3,                                                              3,             9,              5,              5,              9,           255,             9,             3 };    //ini menentukan jumlah karakter diizinkan
        db.show_table(null, false);
        if( !db.err_msg.equals("") ) { error("Pembacaan Data Retur Pembelian Gagal");   return; }

        //set height
        table.setRowHeight(row_height);
        JTableHeader header = new JTableHeader( db.column_model ) { @Override public Dimension getPreferredSize() {
                Dimension d = super.getPreferredSize();
                d.height = row_height + 5;    //retail.round(row_height/4, 1)    //krn banyak__retur butuh dua baris
                return d;
        }};
        header.setFont( new Font("Arial", Font.PLAIN, 14) );    //header.setFont( header.getFont().deriveFont(14f) );
        table.setTableHeader(header);
        table.setFont( new Font("Arial", Font.BOLD, 14) );    //table.setFont( table.getFont().deriveFont(14f) );

        JScrollPane scrollpane = new JScrollPane(table);
        scrollpane.setBounds( 15, 35, Ttotal.getX()+Ttotal.getWidth()-15, Tsub_total.getY()-10-35 );
        scrollpane.setBorder( BorderFactory.createRaisedBevelBorder() );
        panel.setBorder( BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Faktur [F2]" ) );
        // ga ngaruh >>  scrollpane.setFont( scrollpane.getFont().deriveFont(14f) );
        panel.add(scrollpane);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save);

        Bprint = new JBprint(this);
        Bprint.setBounds( Bkeluar.getX(), Bkeluar.getY()-Bkeluar.getHeight()-50, Bkeluar.getWidth(), Bkeluar.getHeight() );  panel.add(Bprint);

        Bexport_xls = new JBexport_xls(this);    //ini harus sesudah init table dan Bsimpan (jika ada) krn constructor JBexport_xls ngebaca component2 tsb.
        Bexport_xls.setBounds( Bkeluar.getX(), Bprint.getY()-Bkeluar.getHeight()-10, Bkeluar.getWidth(), Bkeluar.getHeight() );  panel.add(Bexport_xls);

        Bsimpan.setAlignmentX( Bkeluar.getAlignmentX() );  Bsimpan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bsimpan.setBounds( Bkeluar.getX(), Bexport_xls.getY()-Bkeluar.getHeight()-10, Bkeluar.getWidth(), Bkeluar.getHeight() );  panel.add(Bsimpan);
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        //F10 (Simpan) jarang dipake, jadi gpp berdekatan ama F9 (hapus faktur)
        Bhapus_faktur = new JButton("F9 - hapus faktur", retail.icon_delete_master);  Bhapus_faktur.setAlignmentX( Bkeluar.getAlignmentX() );  Bhapus_faktur.setIconTextGap( Bkeluar.getIconTextGap() );
        Bhapus_faktur.setBounds( Bkeluar.getX(), Bsimpan.getY()-Bkeluar.getHeight()-10, Bkeluar.getWidth(), Bkeluar.getHeight() );  panel.add(Bhapus_faktur);
        Bhapus_faktur.setMnemonic('A');  Bhapus_faktur.addFocusListener(retail.onHover);
        Bhapus_faktur.setEnabled(false);

        panel_wrap.add(panel);
        //ga ngaruh >> panel_wrap.add(panel_agent);    //ini di bawah aja agar table jadi focus yg pertama :p
        //ga ngaruh >> panel_wrap.add(panel_total);    //ini di bawah aja agar table jadi focus yg pertama :p




        Lgambar = new JLabel( "[ Gambar ]", JLabel.CENTER );    Lgambar.setForeground(Color.GRAY);
        Lgambar.setBounds( scrollpane.getX() + scrollpane.getWidth() + 20, scrollpane.getY(), retail.gambar_size, retail.gambar_size ); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        Lgambar.setBorder( BorderFactory.createLoweredBevelBorder() );
        panel.add(Lgambar);

        table.setSelectionMode(0);  //SINGLE_SELECTION
        table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //try{
                if( e.getValueIsAdjusting() ) return;     //Fretur_pembelian.this.setTitle( Fretur_pembelian.this.getTitle() + "last=" + last_selected_row + "   FirstIdx=" +e.getFirstIndex());    //e.getFirstIndex()  Returns the index of the first row whose selection may have changed. where zero is the first row
                int row = table.getSelectedRow();
                //if( row>=0 ) {  Bhapus.setEnabled(true);    menu_hapus.setEnabled(true);  }
                //table.requestFocus();    //container.transferFocusBackward();
                if( row<0 ) return;    //if( row<0 || last_selected_row==row ) return;    //supaya ga diulang2 mulu
                row = table.convertRowIndexToModel( row );  //ini berat sehingga lambat saat filter!!
                if( last_selected_row==row ) return;    //supaya ga diulang2 mulu
                //ga usah aja ... berat dan repot:p. lagian user akan maklum klo gambar akan stay tidak berubah sebelum dia pilih row >> reset_gambar();
                //int row = table.convertRowIndexToModel( table.getSelectedRow() );  //ini berat sehingga lambat saat filter!!
                load_gambar( table.getModel().getValueAt( row, 6).toString() );
                /*
                if( last_selected_row>=0 && last_selected_row<table.getRowCount() && table.getRowCount()==db.getRowCount() ) {    //user batal nginsert row   //dont do when filtered
                    int remove_row = last_selected_row;    //table.convertRowIndexToModel(last_selected_row);
                    String left_val = db.getValueAt(remove_row, 0).toString();
                    if( left_val.equals("0") || left_val.equals("") ) db.removeRow( remove_row );  //user batal nginsert row
                }
                */
                last_selected_row = row;    //Lcari.setText( Lcari.getText() + " " + row);
                //} catch (Exception ex) {    JOptionPane.showMessageDialog( null, "from listselection\n. Pesan Kesalahan: " + ex, "Gagal baca Variable", JOptionPane.ERROR_MESSAGE); }
            }
        });

        //init
        //Tdiskon_edit.setText("0");    //utk menginisiasi Tdiskon_edit.getDocument().getProperty("plain_num") dan sekalian label2 via hitung_total();
        //di construtor aja >> CHppn.setSelected(true);

        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);


        final String sql_hapus_item = " UPDATE barang, beli             \n"   //update barang.stok
                                   +  "     SET stok = stok - banyak    \n"
                                   +  "     WHERE barang_id = barang.id   \n"    //ga perlu krn yg nyimpan pasti form (user) ini >> + " AND user_id= '" + retail.user_id + "'
                                   +  "       AND faktur_id = (SELECT @id:=id FROM beli_faktur WHERE no_faktur = @no_faktur)   ;\n"    //ga perlu krn yg nyimpan pasti form (user) ini >> + " AND user_id= '" + retail.user_id + "'
                                   //nop >> +  " DELETE FROM beli_backup WHERE faktur_backup_id = ( SELECT id FROM beli_faktur_backup WHERE no_faktur = @no_faktur_before ) ;\n"
                                   //nop >> +  " DELETE FROM beli_faktur_backup WHERE no_faktur = @no_faktur_before ;\n"
                                   +  " INSERT INTO beli_faktur_backup SELECT *, @backup_id:=(SELECT IFNULL(MAX(id), 0)+1 FROM beli_faktur_backup), 1 AS retur_action, now(), " +retail.user_id+ " FROM beli_faktur WHERE id = @id AND @no_faktur_before='' ;\n"
                                   +  " INSERT INTO beli_backup SELECT @backup_id, no, barang_id, total, diskon, banyak FROM beli WHERE faktur_id = @id AND @no_faktur_before='' ;\n"    //hmm, pada saat hapus faktur pun, backup aja biar aman klo ada yg tanya2 historynya:p
                                   +  " DELETE FROM beli WHERE faktur_id=@id ;\n" ;     //harus dihapus krn table beli tidak punya unique key krn memang ada kemungkinan di kasir diinput dua item dgn barang yg sama" DELETE FROM beli WHERE faktur_id = (SELECT @id:=id FROM beli_faktur WHERE no_faktur = " +no_faktur+ ") ;\n" ;   //ga perlu krn yg nyimpan pasti form (user) ini >> + " AND user_id= '" + retail.user_id + "'

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( retail.empty( new JTextComponent[]{ Tno_faktur }, new String[]{ Lno_faktur.getText() } ) ) return;    //table.requestFocus() dulu?!
            if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update ... pingin jaga2 aja
            if( !Bsimpan.isEnabled() ) {    //mungkin Bsimpan.setEnabled(false) oleh stopCellEditing() di atas ?!
                JOptionPane.showMessageDialog( Fretur_pembelian.this, "Belum ada data yang bisa disimpan!", "Penyimpanan Data " + modul + " Gagal", JOptionPane.ERROR_MESSAGE);
                return;
            }
            Bsimpan.setEnabled(false);

            String no_faktur_new  = no_faktur;    //isi ini dengan Tno_faktur jika memang user boleh ngupdate no_faktur
            if( no_faktur.equals("belum pernah disimpan") ) {
                no_faktur = "'" + retail.escape( Tno_faktur.getText().trim() ) + "'";
                no_faktur_new  = "'R" + no_faktur.substring( 1, no_faktur.length()-1 ) + "'";    //isi ini dengan Tno_faktur jika memang user boleh ngupdate no_faktur
                no_faktur_before="''";
            }

            //String supplier_id     = "'" + Tcode_agent.getText() + "'";
            jam_faktur             = "";    //new SimpleDateFormat("HH:mm:ss").format(new Date());    //nanti akan dipakai saat print
            //String tgl_faktur      = Ttgl_faktur.getText();    //"'" + new SimpleDateFormat("yyyy-MM-dd").format( Ttgl_faktur.getDate() ) + " " + jam_faktur + "'";    //String tgl_faktur      = "CONCAT( '" + new SimpleDateFormat("yyyy-MM-dd").format( Dtgl_faktur.getDate() ) + " ',  CURRENT_TIME )";
            String diskon_edit     = retail.escape( Tdiskon_edit.getText() );    //getDocument().getProperty("plain_num").toString();

            //String sql_insert_beli_faktur = "";
            String sql = " SET @id = null, @no_faktur =  " + (no_faktur.isEmpty()?"''":no_faktur) + ", @no_faktur_before =  " + (no_faktur_before.isEmpty()?"''":no_faktur_before) + ", @no_faktur_new =  " +no_faktur_new+ "  ;\n" ;   //SET @id sebenarnya ga perlu amat krn gimanapun jg, @id kan kereset di bawah ini.   //ga iso >> " DECLARE id INT DEFAULT NULL ;\n";    //jika @id tetap is null, query berikutnya gak jalan (Column 'faktur_id' cannot be null)
            sql += sql_hapus_item
                +  " UPDATE beli_faktur"
                +  "     SET no_faktur      = @no_faktur_new "    //boleh diedit kagak? klo boleh, ubah isi no_faktur_new di atas
                //+  "         , supplier_id  = " + supplier_id
                //ga perlu diubah??, anyway, there is beli_faktur_backup.tgl_action especially for delete action >> +  "         , tgl_faktur   = " + tgl_faktur
                +  "         , total        = " + (total_faktur-total_round)
                //+  "         , ppn          = " + (CHppn.isSelected()?prosentase_ppn:0)
                +  "         , diskon       = - " + retail.round( (long) Integer.valueOf(diskon_edit) * (sub_total_faktur-sub_total) , 100 )
                +  "         , sub_total    = " + (sub_total_faktur-sub_total)
                +  "         , user_id      = " + retail.user_id
                +  "     WHERE id = @id  ;\n" ;

            //gmn klo hanya ada satu record dan itu masih default (tak perlu diinsert)?  << Bsimpan dah ga enabled:)
            int r=0;    String banyak_cases="";    String barang_ids="";    //sql_stock="";
            for( int i=0; i<db.getRowCount(); i++ ) {
                String barang_id = db.getValueAt(i,8).toString();
                if( barang_id.isEmpty() ) continue;  //user batal nginsert row
                //error dari jdbcnya:( >> You cannot specify target table 'barang' for update in FROM clause >> barang_id = "(SELECT id FROM barang WHERE code='" +barang_id+ "')";    //db.to_db( 0, barang_id );
                int banyak = db.getIntAt(i,3) - db.getIntAt(i,4);    //String banyak = db.to_db( 3, db.getValueAt(i,3) );
                if(r==0) sql +=  " INSERT INTO beli ( faktur_id,      no      ,     barang_id    ,                               total                                                        ,     banyak    ,           diskon                                                                    ) VALUES  \n" ;    //jika @id is null query berikut gak jalan (Column 'faktur_id' cannot be null) >> sql =  " SET @id='fail'    ;\n"  //ah, ternyata dia tetap insert dengan @id=0 ... so biarin ajaahhhh, paling2 datanya banjir :) //biar ga lanjut klo query sebelum ini fail.
                else     sql +=  " , " ;
                sql +=           "                  (       @id, " + (i+1) + ", " + barang_id + ", " + retail.round( (long) db.getIntAt(i, 2) * (100 - db.getIntAt(i, 5)) * banyak , 100 ) + ", " + banyak + ", " + retail.round( (long) db.getIntAt(i, 2) * db.getIntAt(i, 5) * banyak , 100 ) + " )  \n"  ;         //sql +=  "(@id, " + (1+Ccode_brg.getSelectedIndex()) + ", " + (Integer)db.getValueAt(i,5) + ", " + (Integer)db.getValueAt(i,3) + ", " + (Integer)db.getValueAt(i,4) + ")  \n"  ;
                //tapi apa iya ada yg bawa barang ke kasir, padahal stoknya ga ada:) ... anyway, barang.stok need to NOT unsigned >> dari Fpenjualan, sebaiknya si cek dulu apa stok cukup ... klo dari form interface, kurang perfect deh:)
                //sql_stock += " UPDATE barang SET stok = stok + IF(@id IS NULL, 0, " +banyak+ ") WHERE id = " + barang_id + " ;\n" ;
                banyak_cases += " WHEN " + barang_id + " THEN " + banyak ;
                if( r>0 ) barang_ids += ", " ;
                barang_ids += barang_id;
                r++;
            }
            if( r>0 )  sql += " ;\n"
                           +  " UPDATE barang SET stok = stok + IF(@id IS NULL, 0, CASE id " +banyak_cases+ " ELSE 0 END ) WHERE id IN (" + barang_ids + ") ;\n" ;    //sql_stock;

            db.exec(sql, null, true);

// JOptionPane.showMessageDialog( Fretur_pembelian.this, "no_faktur=" + no_faktur+ "  no_faktur_new="+no_faktur_new + "\n"+ sql, modul + " 111", JOptionPane.ERROR_MESSAGE);

            /*
            //saat simpan no_faktur, anyway tetap hrs tangani duplicate dengan autoinsert dengan cara nambahin auto number krn dia boleh diedit user!
            //The value of LAST_INSERT_ID() is not changed if you update the AUTO_INCREMENT column of a row with a non-magic value (that is, a value that is not NULL and not 0). >> sql += " SET @id = IF( @id=LAST_INSERT_ID(id+1)  ;\n" ;
            if( db.err_msg.indexOf("sudah pernah disimpan" ) >= 0)    //loop ini hanya ngulang klo duplicate beli_faktur.id
                for( int i=0; i<1000; i++ ) {
                    String no_faktur_loop = no_faktur_new.substring( 0, no_faktur_new.length()-1 ) + "#" + String.valueOf(i+1) + "'";
                    sql = " SET @no_faktur_new = " +no_faktur_loop+ "  ;\n"
                        + sql_insert_beli_faktur ;
                    db.exec(sql, null, true);
                    if( db.err_msg.indexOf("sudah pernah disimpan") < 0 ) { //berhasil insert tanpa duplikasi
                        no_faktur_new     = no_faktur_loop  ;   //to use next
                        Tno_faktur.setText( no_faktur_new.substring( 1, no_faktur_new.length()-1 ) );
                        Bsimpan.setEnabled(false);    //gara2 di atas:)
                        break;
                    }
                }   //end of for loop
            */

            if( db.err_msg.equals("") ) {
                no_faktur_before=no_faktur;
                no_faktur=no_faktur_new;
                no_faktur_hapus=no_faktur_new;
                Tno_faktur.setText( no_faktur.substring( 1, no_faktur.length()-1 ) );
                //not here >> Bhapus_faktur.setEnabled(true);
                //Bkosongkan.doClick();
            } else {
                if( no_faktur.isEmpty() ) no_faktur=no_faktur_new;    //hanya biar ga insert melulu .... banjir ntar
                JOptionPane.showMessageDialog( Fretur_pembelian.this, db.err_msg + sql, "Penyimpanan Data " + modul + " Gagal", JOptionPane.ERROR_MESSAGE);
                Bsimpan.setEnabled(true);
            }
            table.requestFocus();
        }});

        Blihat.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update ... pingin jaga2 aja
            if( Bsimpan.isEnabled() ) {
                int resp = JOptionPane.showOptionDialog( Fretur_pembelian.this, "\nPerubahan data ingin disimpan lebih dulu?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                table.requestFocus();
                if( resp==0 ) {        //"YA"
                    Bsimpan.doClick();    if( Bsimpan.isEnabled() ) return;    //simpan gagal
                } else if( resp==1 ) { //"TIDAK"
                } else               { //"BATAL"
                    return;
                }
            }
            clear_form();
            String no_faktur_temp = "'" + retail.escape( Tno_faktur.getText().trim() ) + "'";
            //ga jadi >> if( no_faktur_temp.equals("''") ) return;   //krn ini dipanggil jg oleh Bhapus_faktur() :p :)

            //show the data
            String sql = " SELECT brg.code AS dump, brg.name, brg.harga_beli, i.banyak, 0 AS banyak_retur, CAST( 100*i.diskon/i.total AS SIGNED) AS diskon, brg.gambar, 0 AS total_retur, barang_id "
                       + "        , f.tgl_faktur, f.total, f.ppn, CAST( 100*ABS(f.diskon)/f.sub_total AS SIGNED)  AS diskon_edit, f.sub_total, f.user_id "
                       + "        , agent.code, agent.name AS name1, agent.kontak AS kontak_agent "
                       + " FROM beli i"
                       + " INNER JOIN beli_faktur f ON i.faktur_id=f.id"
                       + " LEFT  JOIN barang brg ON i.barang_id=brg.id"
                       + " LEFT  JOIN supplier agent ON f.supplier_id=agent.id"
                       + " WHERE f.no_faktur=" +no_faktur_temp
                       + " ORDER BY i.no"
                       ;
            db.exec( sql, null, true );
            if( !db.err_msg.equals("") ) { JOptionPane.showMessageDialog( Fretur_pembelian.this, "\nMaaf, Data Pembelian dengan No. Faktur \"" +Tno_faktur.getText()+ "\" .....\n" +db.err_msg+ "\n\n\n\n\n", "Pembacaan Data Pembelian Gagal", JOptionPane.ERROR_MESSAGE);    return; }    //don't close:p >> error("Pembacaan Data Pembelian");
            if( db.rs.size() <= 0 )      { JOptionPane.showMessageDialog( Fretur_pembelian.this, "\nMaaf, Data Pembelian dengan No. Faktur \"" +Tno_faktur.getText()+ "\" tidak ditemukan!\n\n\n\n\n", "Data tidak ditemukan", JOptionPane.ERROR_MESSAGE);    Tno_faktur.requestFocus();    return; }
            try {
                Object[] rs_row = new Object[db.col_width.length];
                int[] col_type  = new int   [db.col_width.length];
                while( db.rs.next() ) {
                    if(col_type[0]==0) {    //only on first row
                        Tname_agent.setText  ( db.rs.getString(17  ) );    //Tname_agent.setText  ( db.rs.getString("code_1"  ) );    //invalid columname?!, alias AS juga ga jalan kecuali utk banyak_return. Hm... padahal ini benar >> db.rs.getMetaData().getColumnLabel(15)
                        Tcode_agent.setText  ( db.rs.getString(16  ) );
                        Tkontak_agent.setText( db.rs.getString("kontak"      ) );
                        Ttgl_faktur.setText  ( new SimpleDateFormat("EEEE,  dd-MM-yyyy  HH:mm:ss").format( db.rs.getDate("tgl_faktur"  ) ) );
                        Tdiskon_edit.setText ( db.rs.getString(13  ) );
                        CHppn.setSelected    ( db.rs.getInt("ppn")>0           );
                        sub_total_faktur     = db.rs.getInt("sub_total") ;
                        total_faktur         = db.rs.getInt("total") ;
                        Ttotal_faktur.setText( String.format("%,d", total_faktur) );
                    }
                    for( int i=0; i<db.col_width.length; i++ ) {  //klo ga gini, kebanyakan try{} ntar
                        rs_row[i] = db.rs.getObject(i+1);
                        if(col_type[i]==0) col_type[i] = db.metaData.getColumnType(i+1);
                    }
                    db.addRow(rs_row,col_type);
                }
                db.rs.close();
                db.fireTableDataChanged();    //perlu krn addrow di atas sudah gak ada fireinsertednya:p
                no_faktur = "belum pernah disimpan";    //"'R" + no_faktur_temp.substring( 1, no_faktur_temp.length()-1 ) + "'";    //utk digunakan di Bsimpan
                no_faktur_hapus = "'" + no_faktur_temp.substring( 1, no_faktur_temp.length()-1 ) + "'";    //utk digunakan di Bhapus_faktur
                no_faktur_before=no_faktur;    //utk menghapus beli_faktur_backup jika form ini menyimpan retur berulangkali
                set_enable_tombol2(true);
                Blihat.setEnabled(false);
                //hitung_total();
            } catch (Exception ex) {
                db.err_msg += "\nMaaf, Data \"Pembelian\" gagal dibaca!\n\n\n(" + ex + ")";
                error("Pembacaan Data Pembelian");   return;
            }
            last_selected_row = -1;    //ngumpanin ListSelectionListener() ... agar tetap load_gambar
            table.setRowSelectionInterval(table.getRowCount()-1,table.getRowCount()-1);    table.setColumnSelectionInterval(4,4);    table.scrollRectToVisible( table.getCellRect( table.getSelectedRow(), table.getSelectedColumn(), true ) );    //load_gambar( rs_row[6].toString() );
        }});

        Bhapus_faktur.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( no_faktur.isEmpty() ) return;    //blm ada kebuka di table
            if( 0 != JOptionPane.showOptionDialog( Fretur_pembelian.this, "\nFaktur ini (No. Faktur: " +no_faktur_hapus+ ") ingin dihapus dari database?\n\n\n\n", "Konfirmasi", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions2, null) )   return;    //lah, gmn klo no_faktur diedit user tp blm disimpan? :p  >> Faktur dengan no_faktur \"" +no_faktur+ "\" ingin dihapus dari database?
            Bhapus_faktur.setEnabled(false);
            String sql = " SET @id = null, @no_faktur = " +no_faktur_hapus+ "  ;\n"   //SET @id sebenarnya ga perlu amat krn gimanapun jg, @id kan kereset di bawah ini.   //ga iso >> " DECLARE id INT DEFAULT NULL ;\n";    //jika @id tetap is null, query berikutnya gak jalan (Column 'faktur_id' cannot be null)
                       +   sql_hapus_item.replace("1 AS retur_action", "2 AS retur_action")
                       + " DELETE FROM beli_faktur WHERE id = @id  ;\n" ;
            db.exec(sql, null, true);
            if( !db.err_msg.equals("") ) {
                JOptionPane.showMessageDialog( Fretur_pembelian.this, db.err_msg, "Penghapusan Data Faktur " + no_faktur_hapus + " Gagal", JOptionPane.ERROR_MESSAGE);
                Bhapus_faktur.setEnabled(true);
                Tno_faktur.requestFocus();
                return;
            }
            clear_form();
            Tno_faktur.setText("") ;
            //Blihat.doClick();    //haha, aku baru tau klo ini ga mau jalan klo tombol itu ga enabled
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update ... pingin jaga2 aja
                if( !Bsimpan.isEnabled() ) { close(); return; }
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) {        //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  @Override public void windowClosing(WindowEvent e) {
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update jika icon close diklik atau ALT-F4 :)  //ga mo cerewet ah:)) >> if( !db.err_msg.equals("") ) { error("Update Data Gagal");   return; }
                Bkeluar.doClick();
            }
        });

        retail.removeTitleButtons(this, onClose);
        Tno_faktur.requestFocus();    //:)  table.setRowSelectionInterval(0,0);    table.setColumnSelectionInterval(0,0);    //table.editCellAt( 0, 3 );
        set_enable_tombol2(false);
        setVisible(true);
        //} catch (Exception e) {            JOptionPane.showMessageDialog( null, "create form gagal: " + e, "Pembacaan Data Barang", JOptionPane.ERROR_MESSAGE);     close();   return;  }
    }


    void clear_form() {
        Tcode_agent.setText("");
        Tname_agent.setText("");
        Tkontak_agent.setText("");
        Ttgl_faktur.setText("");
        Tdiskon_edit.setText("0");
        CHppn.setSelected(false);
        total_faktur = 0;
        hitung_sub_total();
        reset_gambar();
        Ttotal_faktur.setText("");    //supaya tidak berisi "0" oleh hitung_sub_total() di atas

        //retail.add_row(table);    //db.addRow();
        no_faktur = "";    //supaya isinya berubah hanya jika load data berhasil
        no_faktur_hapus = "";
        //Bhapus_faktur.setEnabled(false);
        set_enable_tombol2(false);
        Bsimpan.setEnabled(false);

        db.rows.clear();
        db.fireTableDataChanged();
        Tno_faktur.requestFocus();    //aturan logic dasar deh, balikin ke situ lagi:) >> table.requestFocus();
    }

    void close() {
        timer_title.stop();    timer_total.stop();    //take my whole day to investigate the problem he create:p
        try { db.rs.close(); } catch (Exception e) {}
        db.close(); table.setRowSorter(null);  //sorter=null;  //aneh aja ... tanpa ini, jika row diubah urutannya trus didelete, lalu ditutup-buka lagi, terjadi error saat fireTableRowsInserted(getRowCount()-1, getRowCount()-1);
        //db.setAutoCommit(tempAutoCommit);
        //retail.Ccode_brg.putClientProperty(JLabel.LABELED_BY_PROPERTY, null);    //JComponent.NEXT_FOCUS    //retail.tbl_brg = null;
             //Cname_brg.removeItemListener(sync_brg);  Ccode_brg.removeItemListener(sync_brg);    //dia nempel di retail.Ccode_brg :p
//table.putClientProperty("terminateEditOnFocusLost", false); //Paling tidak utk memaksa update terjadi saat filtering table:p >> Note that this solution will cause the table to stop editing when any component get focus. I believe this logic is limited to components on the current window, but must admit I havent tested it. This solution will also not work when you click on the window buttons (ie, minimize or close).
        
        //retail.remove_CellEditor(table);
        db=null;    table=null;
        dispose();
    }
    void error(String title) {
        JOptionPane.showMessageDialog( this, db.err_msg, title, JOptionPane.ERROR_MESSAGE);
        close();
    }

    void reset_gambar() {
        if( Lgambar.getText()!="" ) return;
        Lgambar.setIcon(null);
        Lgambar.setText( "[ Gambar ]" );
    }
    void load_gambar( String gambar_filename ) {
        gambar_filename = gambar_filename.trim();
        if( !gambar_filename.equals("") ) {
            retail.load( Lgambar, gambar_filename );  //if( !retail.load( Lgambar, gambar_filename ).equals("") )
            if( Lgambar.getIcon()==null ) reset_gambar();    //berarti load imagenya gagal
        } else if( Lgambar.getText()==""  )            reset_gambar();
    }

    //hitung sub_total dan total di bawah ini sudah melalui proses pembulatan 0 decimal pada masing2 itemnya:), mungkin later ingin diperbaiki:)
    void hitung_sub_total() {
//try{
        if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update ... pingin jaga2 aja
        sub_total=0;
        for( int i=0; i<table.getRowCount(); i++ ) {
            sub_total += db.getIntAt(i, 7);       //temp += (long)( getIntAt(i, 2) * (100 - getIntAt(i, 4) ) * getIntAt(i, 3) );
            if( sub_total<0 ) {   //exceed int max: 2.147.483.647
                JOptionPane.showMessageDialog( table,  "Total harga terlalu besar.", "Kesalahan", JOptionPane.ERROR_MESSAGE );
                sub_total=0;
                break;
            }
        }
        Tsub_total.setText( String.format("%,d", sub_total) ) ;
        //set_enable_tombol2(true);
        hitung_total();
        //} catch (Exception e) {            JOptionPane.showMessageDialog( null, "bvvvvl: " +t + e, "Pembacaan Data Barang", JOptionPane.ERROR_MESSAGE);     close();   return;  }
    }

    void hitung_total() {
//try{
        if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update ... ini penting
        diskon = retail.round( (long) sub_total * Integer.valueOf(Tdiskon_edit.getText()) , 100 ) ;    //diskon = retail.round( (long) sub_total * ((Integer)Tdiskon_edit.getDocument().getProperty("plain_num")) , 100 ) ;    //((Float)( sub_total * ((Integer)doc.getProperty("plain_num")) / 100 ) ).intValue();
        Tdiskon.setText( String.format("%,d", -1*diskon) ) ;
        total = sub_total - diskon;

        ppn = CHppn.isSelected() ? retail.round( (long)total*prosentase_ppn, 100 ) : 0 ;
        Tppn.setText( String.format("%,d", ppn) ) ;

        int pembulatan = 100;
        try { pembulatan = Integer.valueOf( db.cfg.get("pembulatan_rupiah") );    } catch( Exception e ) {}

        total += ppn ;    //total = Tdiskon.getText().equals("") ? 0 : Integer.valueOf(Tdiskon.getText());
        int total_round_temp = total_round;
        total_round = retail.round( (long)total, pembulatan) * pembulatan;    //total_round = Math.round(2/3) * 100; //(total/100)
        Ttotal.setText( String.format("%,d", total) ) ;
        Ltotal_blink.setText( " " + String.format("%,d", total_round) );
        Ttotal_faktur.setText( String.format("%,d", total_faktur-total_round ) );    //Ttotal_faktur.getText().isEmpty() ? 0 : Integer.valueOf( Ttotal_faktur.getText().replace(retail.digit_separator, "") ) - total_round ;

        if( total_round!=total_round_temp ) Bsimpan.setEnabled(true);    //user perlu mengundo:p >> Bsimpan.setEnabled(total_round>0)    //aku pinter ga ya:)
        //} catch (Exception e) {            JOptionPane.showMessageDialog( null, "total: " +t + e, "Pembacaan Data Barang", JOptionPane.ERROR_MESSAGE);     close();   return;  }
    }

    void enable_Bsimpan() {
        if( table.getRowCount()>1 )    Bsimpan.setEnabled(true);
        else if( table.getRowCount()==1 )
                 if( !table.getValueAt(0,0).toString().isEmpty() && !table.getValueAt(0,1).toString().isEmpty() )     //if( !db.getValueAt(0,0).toString().isEmpty() && !db.getValueAt(1,0).toString().isEmpty() )
                     Bsimpan.setEnabled(true);   //kode dan item keduanya harus dicek apa masi empty krn belum dipost editnya.
    }

    void set_enable_tombol2( Boolean enable ) {    //berdasarkan isi table: kosong ato berisi
        //Bsimpan.setEnabled(enable);
        Bprint.setEnabled(enable);    Bexport_xls.setEnabled(enable);
        Bhapus_faktur.setEnabled(enable);
    }



    //to print
    public Object[][] title_header() {
        Boolean member = !Tname_agent.getText().equals("Umum") ;
            Object[][] title_header = {
                  { retail.convert_null(retail.setting.get("Nama Perusahaan")).toUpperCase() }
                , { retail.convert_null(retail.setting.get("Alamat"))                        }
                , { retail.convert_null(retail.setting.get("Tag"))                           }
                , { "" }
                , {"RETUR PEMBELIAN" }
                , { Ttgl_faktur.getText()   }    //new SimpleDateFormat("EEEE, d MMMM yyyy").format( Dtgl_faktur.getDate() ) + " - " + jam_faktur
                , {"No. Faktur"    , ":  " + ( no_faktur_hapus.isEmpty()?"":no_faktur_hapus.substring( 1, no_faktur_hapus.length()-1 ) )  }    //pada Bexport_xls onclick, ini dipanggil dua kali, yg pertama hanya utk ambil nama file:p ... pdhl no_faktur belum ada krn belum disimpan
                //, {"Tgl. Faktur"   , ":  " + Ttgl_faktur.getText() }    //, {"Tgl. Faktur"   , ":", new SimpleDateFormat("EEEE, d MMMM yyyy").format( Dtgl_faktur.getDate() ) + " - " + jam_faktur }
                , {"Kasir"         , ":  " + retail.nama                              }
                , {"Member"        , ":  " + ( member ? Tcode_agent.getText() : "-" ) }
                , {"Nama"          , ":  " + ( member ? Tname_agent.getText() : "-" ) }
                };
            return title_header;
    }
    public Object[][] table_summary() {
        Object[][] table_summary = {
              {"Sub Total Retur" , ":  Rp. ", Tsub_total.getText() }
            , {"Potongan"        , ":  Rp. ", Tdiskon.getText() }
            , {"PPN"             , ":  Rp. ", Tppn.getText() }
            , {"Total Retur"     , ":  Rp. ", Ltotal_blink.getText() }
            , {"Total Faktur"    , ":  Rp. ", Ttotal_faktur.getText() }
            };
        return table_summary;
    }


//    void hitung_kembalian(Document doc) {  // throws BadLocationException {
//try {

//Integer.valueOf() kok lambat sekali?!

        //Lkembali.setText( String.format( "%,d", Integer.valueOf( doc.getText( 0, doc.getLength() ).replace(retail.digit_separator, "") ) - Integer.valueOf( Ltotal.getText().replace(retail.digit_separator, "") ) ) ) ;
        //Lkembali.setText( ((Integer)(doc.getProperty("plain_num"))).toString() ) ;
//Lkembali.setText( String.format( "%,d", (Integer)(doc.getProperty("plain_num")) - total ) ) ;
        //Lkembali.setText( Integer.valueOf( Tdibayar.getText().replace(retail.digit_separator, "") ).toString() ) ; //ga tau knapa kok lambat bgt klo dibaca lewat documentlistener

        //Lkembali.setText( String.format( "%,d", Integer.valueOf( Tdibayar.getDocument().getText( 0, Tdibayar.getDocument().getLength() ).replace(retail.digit_separator, "") ) - Integer.valueOf( Ltotal.getText().replace(retail.digit_separator, "") ) ) ) ;
        //Lkembali.setText( String.format( "%,d", Integer.valueOf( Tdibayar.getText().replace(retail.digit_separator, "") ) - Integer.valueOf( Ltotal.getText().replace(retail.digit_separator, "") ) ) ) ;
//} catch( BadLocationException e) {}

//    }

}