/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

public class Ftambah_penukaran_poin extends Ftambah {
    public JCdb Ccode_agent;    //blm ditest:p >> //utk dibaca di class celleditor untuk otomatis beralih dari scan barcode barang
    JComboBox Ckontak_agent;
    JTextField Tjumlah;  JTextField Tketerangan;  JTextField Tpoin;
    int agent_id = -13;  int poin_save=0;    int pelanggan_idx_save=0;
    AbstractDocument doc;

    public Ftambah_penukaran_poin(final Window parent) {
        super(parent, "Penukaran Poin");
        modul = "Penukaran Poin";

        JLabel Ljumlah = new JLabel("Poin Ditukar", JLabel.LEFT);
        Ljumlah.setBounds(90, 210, 70-3, 35);  panel.add(Ljumlah);
        Tjumlah = new JTextField(9);
        Tjumlah.setBounds( 15 + panel.getComponent(3).getX() + panel.getComponent(3).getWidth(), panel.getComponent(3).getY()+3, 200, 29 );  panel.add(Tjumlah);

        JLabel Lketerangan = new JLabel("Keterangan", JLabel.LEFT);  panel.add(Lketerangan);
        Tketerangan = new JTextField(255);  panel.add(Tketerangan);

        comp_number.add(Tjumlah);
        align_comps();
        Tketerangan.setSize( new Dimension(500, Tketerangan.getHeight()) );
        //Lketerangan.setDisplayedMnemonic( 'E' );

        JPanel panel_agent = new JPanel(null);
        panel_agent.setBounds( Ljumlah.getX(), Ljumlah.getY() - 130, 5+Lketerangan.getWidth() + Tketerangan.getWidth(), 117);
        panel_agent.setBorder( BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Pelanggan" ) );
        JLabel Lname_agent = new JLabel("Nama");          Lname_agent.setBounds( 25+11+4, 29, 47-7, 29);  Lname_agent.setForeground(Color.GRAY);  Lname_agent.setDisplayedMnemonic('A');  panel_agent.add(Lname_agent);
        final JComboBox Cname_agent = new JComboBox();    Cname_agent.setBounds( 2+Lname_agent.getX() + Lname_agent.getWidth(), Lname_agent.getY()+5, 230+20+160, Lname_agent.getHeight() );  Lname_agent.setLabelFor(Cname_agent);  panel_agent.add(Cname_agent);
        JLabel Lcode_agent = new JLabel("Kode");          Lcode_agent.setBounds( 2+Cname_agent.getX()+70    + 80+15+40  +5+17, Lname_agent.getY()+Lname_agent.getHeight()+7, 25+5, Lname_agent.getHeight() );  Lcode_agent.setForeground( Lname_agent.getForeground() );  Lcode_agent.setDisplayedMnemonic('D');  panel_agent.add(Lcode_agent);    //Lcode_agent.setBounds( Lname_agent.getX(), Lname_agent.getY()+Lname_agent.getHeight()+7, Lname_agent.getWidth(), Lname_agent.getHeight() );  
        Ccode_agent = new JCdb("");                       Ccode_agent.setBounds( 2+2+Lcode_agent.getX()+Lcode_agent.getWidth(), Lcode_agent.getY()+5, 80+15+40 +9+3, Cname_agent.getHeight() );  Lcode_agent.setLabelFor(Ccode_agent);  panel_agent.add(Ccode_agent);    //Ccode_agent.setBounds( Cname_agent.getX(), Lcode_agent.getY()+5, 80+15+40, Cname_agent.getHeight() );  
        if( retail.convert_null(retail.setting.get("Prefer Barcode")).toLowerCase().equals("ya") )  { 
            Ccode_agent.setEditable(true);
            Ccode_agent.setName("barcode target");    //utk dipakai di event dispatcher agar barcode hanya bisa masuk sini.
        }
        JLabel Lkontak_agent = new JLabel("Poin");        Lkontak_agent.setBounds( Lname_agent.getX(), Lname_agent.getY()+Lname_agent.getHeight()+7, Lname_agent.getWidth(), Lname_agent.getHeight() );  Lkontak_agent.setForeground( Lname_agent.getForeground() );  Lkontak_agent.setDisplayedMnemonic('I');  panel_agent.add(Lkontak_agent);    //Lkontak_agent.setBounds( Ccode_agent.getX()+Ccode_agent.getWidth()+5+20, Lcode_agent.getY(), 25+5, Lname_agent.getHeight() );  
        Ckontak_agent = new JComboBox();                  Ckontak_agent.setBounds( Cname_agent.getX(), Lcode_agent.getY()+5, 70, Cname_agent.getHeight() );  Lkontak_agent.setLabelFor(Ckontak_agent);  panel_agent.add(Ckontak_agent);    //Ckontak_agent.setBounds( 2+Lkontak_agent.getX()+Lkontak_agent.getWidth(), Lkontak_agent.getY()+5, 70, Cname_agent.getHeight() );  
        Tpoin = new JTextField();  Tpoin.setEditable(false);  Tpoin.setBackground(retail.disabled_color);  //Tpoin.setFont( new Font( "Kartika", Font.BOLD, 20 ));  //Tpoin.setMargin( new Insets( 0, 0, 0, 7 ) );
        Tpoin.setBounds( 1+Ckontak_agent.getX()+Ckontak_agent.getWidth(), Ckontak_agent.getY(), Cname_agent.getWidth() - Ccode_agent.getWidth() - 5 - Lkontak_agent.getWidth() - Ckontak_agent.getWidth() - 2 - 2-20  +9-4, Cname_agent.getHeight() );  panel_agent.add(Tpoin);    //Tpoin.setBounds( 2+Ckontak_agent.getX()+Ckontak_agent.getWidth(), Ckontak_agent.getY(), Cname_agent.getWidth() - Ccode_agent.getWidth() - 5 - Lkontak_agent.getWidth() - Ckontak_agent.getWidth() - 2 - 2-20, Cname_agent.getHeight() );  

        db.exec( "SELECT id, name, code, poin FROM pelanggan ORDER BY IF(id=1,-111,name)" , null, true );    //    //mending by name, krn klo BY id dia pastinya udah hafal (ato ada guideline dari kode barcode)    //db.exec( "SELECT id, name, code, kontak, diskon FROM pelanggan ORDER BY id" , null, true );
        if( !db.err_msg.equals("") ) { error("Pembacaan Data Pelanggan");   return; }     //Lname_agent.setFont( new Font("Times New Roman", Font.PLAIN, 12) );
        try {
            while( db.rs.next() ) {
                Cname_agent.addItem  ( db.rs.getString(2) );
                Ccode_agent.addItem  ( new jcdb_item( db.rs.getInt(1), db.rs.getString(3) ) );
                Ckontak_agent.addItem( db.rs.getString(4) );
            }
            db.rs.close();
        } catch (Exception e) {
            db.err_msg += "\nMaaf, Data \"Pelanggan\" gagal diinisiasi!\n\n\n(" + e + ")";
            error("Pembacaan Data Pelanggan");   return;
        }

        ItemListener sync_agent = new ItemListener() { public void itemStateChanged(ItemEvent e) {
            if( agent_id>-13 ) return;  //supaya tidak listen setSelectedIndex yg dilakukan program.
            if( e.getStateChange()!=ItemEvent.SELECTED ) return;
            if( Cname_agent.getSelectedIndex()==Ccode_agent.getSelectedIndex() && Cname_agent.getSelectedIndex()==Ckontak_agent.getSelectedIndex() ) return;  //supaya tidak ngulang ampe 2 kali:p
            agent_id = ((JComboBox)e.getItemSelectable()).getSelectedIndex();
            if( e.getItemSelectable() != Cname_agent   ) Cname_agent.setSelectedIndex(agent_id);
            if( e.getItemSelectable() != Ccode_agent   ) Ccode_agent.setSelectedIndex(agent_id);
            if( e.getItemSelectable() != Ckontak_agent ) Ckontak_agent.setSelectedIndex(agent_id);
            show_poin();
            agent_id = -13;
        }};
        Ccode_agent.setSelectedIndex(-1);    Cname_agent.setSelectedIndex(-1);    Ckontak_agent.setSelectedIndex(-1);    //supaya bisa langsung in action at the first time saat di bawah diset Cname_agent.setSelectedIndex(0)
        Cname_agent.addItemListener(sync_agent);  Ccode_agent.addItemListener(sync_agent);  Ckontak_agent.addItemListener(sync_agent);
        panel.add(panel_agent);

        doc = (AbstractDocument) Tjumlah.getDocument();
        doc.addDocumentListener( new DocumentListener() {
            public void changedUpdate(DocumentEvent e) {
                show_poin();
            }
            public void removeUpdate(DocumentEvent e) { changedUpdate(e); }
            public void insertUpdate(DocumentEvent e) { changedUpdate(e); }
        });    Tjumlah.setText("0");    Tjumlah.setText("");    Bsimpan.setEnabled(false);    Bkosongkan.setEnabled(false);    //utk mancing Property("plain_num") :p

        mandatory.add(Tjumlah);    //mandatory.add(Tpoin);
        Ccode_agent.requestFocus();
        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                Ccode_agent.requestFocus();
                ((JTextComponent) ((JCdb)Ccode_agent).getEditor().getEditorComponent()).selectAll();
        }});
        setVisible(true);
    }
    void show_poin() {
        //String poin = Tjumlah.getText().replace(retail.digit_separator,"");
        int poin = ((Integer)doc.getProperty("plain_num"));    //Integer.valueOf(poin);
        int selectedIndex = Ccode_agent.getSelectedIndex();    //java bug? : he gives the first found the same item >> Ckontak_agent.getSelectedIndex();
        int poin_before   = selectedIndex<0 ? 0 : Integer.valueOf(Ckontak_agent.getSelectedItem().toString()) ;
        if( db.err_msg.equals("") && poin_save>0 ) {    //kudu update combo poin!
            agent_id = -1;    //supaya itemlistener tidak listen setSelectedIndex yg dilakukan program di bawah ini.
            int poin_before_save = poin_before;
            if( selectedIndex!=pelanggan_idx_save ) {
                selectedIndex = -111;
                poin_before_save = Integer.valueOf(Ckontak_agent.getItemAt(pelanggan_idx_save).toString());
            }
            Ckontak_agent.removeItemAt( pelanggan_idx_save );
            Ckontak_agent.insertItemAt( poin_before_save - poin_save, pelanggan_idx_save );
            if( selectedIndex>=0 ) Ckontak_agent.setSelectedIndex(selectedIndex);
            poin_save=0;
            agent_id = -13;
        }
        if( poin>0 && poin<poin_before ) Tpoin.setText( "- " + poin + " = " +  ( poin_before - poin ) );
        else                             Tpoin.setText("");    //ini akan bikin simpan dibatalkan. Anyway, sebaiknya si ada warning bahwa poin yg hendak ditukarkan lebih besar nilainya! di onfocuslost? .. ngunci dong:)
    }
    @Override Boolean build_sql() {
        poin_save = ((Integer)doc.getProperty("plain_num"));
        if( poin_save<=0 || Tpoin.getText().isEmpty() ) {
            String msg = "Poin pelanggan harus lebih besar dari poin yang hendak ditukarkan!" ;
            if( poin_save<=0 ) msg = "Mohon isi \"Poin Ditukar\"!" ;
            Tjumlah.requestFocus();  Tjumlah.selectAll();
            JOptionPane.showMessageDialog( this, msg + "\n\n\n\n\n" , "Isian Harus Diperbaiki", JOptionPane.ERROR_MESSAGE);
            return false;
        }
        int pelanggan_id = ((jcdb_item)Ccode_agent.getSelectedItem()).get_id();
        sql = " SET @succeed=0 ;\n"
            + " UPDATE pelanggan SET poin = poin - " +poin_save+ " + 1-(@succeed:=1) WHERE id = " +pelanggan_id+ " AND poin >= " +poin_save+ "  ;\n"
            + " INSERT INTO penukaran_poin (             id         ,     pelanggan_id,          poin,                                                                          keterangan,                             user_id ) "
            +                  " SELECT IFNULL( MAX(poin.id), 0) + 1, " + pelanggan_id + " , " + Tjumlah.getText().replace(retail.digit_separator,"") + " , '" + retail.escape(Tketerangan.getText()) + "' , " + retail.user_id
            +                  "   FROM penukaran_poin poin "
            +                  "   WHERE @succeed=1  ;\n"  ;    //jika poin di db ternyata kurang, raise error:) >> if( affected <= 0 ) err_msg += "\nMaaf, Tidak ada data yang bisa diupdate!\n\n\n\n\n";
            //+                  "   INNER JOIN pelanggan ON pelanggan_id=pelanggan.id "
            //+                  "   WHERE pelanggan.id = " +pelanggan_id+ " AND pelanggan.poin >= " +poin_save+ "  ;\n"  ;    //jika poin di db ternyata kurang, raise error:) >> if( affected <= 0 ) err_msg += "\nMaaf, Tidak ada data yang bisa diupdate!\n\n\n\n\n";
        this.params=null;
        pelanggan_idx_save = Ccode_agent.getSelectedIndex();    //java bug? : he gives the first found the same item >> Ckontak_agent.getSelectedIndex();
        return true;
    }
    void error(String title) {
        JOptionPane.showMessageDialog( this, db.err_msg, title, JOptionPane.ERROR_MESSAGE);
        close();
    }
}